<?php
	class Player {
		// CLASSES
		private $sql = NULL;
		private $tpl = NULL;
		private $func = NULL;
		private $settings = NULL;
		private $stats = NULL;
		
		// VARIABLES
		// Array of Stats-tables
		private $tables = Array(
			"assignments", 
			"awards", 
			"dogtags", 
			"kititems", 
			"stats", 
			"vehicleCategory", 
			"vehicles", 
			"weapons",
			"weaponCategory"
		);
		
		// Array of Stats-tables for history function
		private $history = Array( 
			"stats",
		);
		
		
		public function __construct() {
			$this->sql  = new MySQL();
			$this->func = new Functions();
			$this->settings = new Settings();
			$this->stats = new Stats();
			$this->tpl  = new Templates();
			$this->tpl->load_phrases("admin", true);
		}
		
		
		public function add($name, $platform, $update=true) {
			$name = trim($name);
			
			// Check if name is given
			if ($name == "") {
				return $this->tpl->phrase("message_no_player_given");
			}
			
			// Name is given...
			else {
				// Check if the name is already in the database
				$this->sql->query('SELECT id FROM '.$this->sql->prefix.'player WHERE name = "'.$name.'" AND platform = "'.$platform.'"');
				
				if($this->sql->count()) {
					// Name is already in the database. Generate message with $name in phrase
					$message = $this->tpl->phrase("message_player_already_added");
					eval ( "\$message = \"$message\";" );
					return $message;
				} 
				else {
					// Name is not in the database yet. Create a entry in the "player" table ...
					$this->sql->query('INSERT INTO '.$this->sql->prefix.'player (name, platform) VALUES ("'.$name.'", "'.$platform.'")');
					$playerid = $this->sql->id;
					
					
					// ... and in all stats tables
					$this->sql->query('INSERT INTO '.$this->sql->prefix.'stats__basic (id) VALUES ("'.$playerid.'")');
					foreach ($this->tables as $table) {
						$this->sql->query('INSERT INTO '.$this->sql->prefix.'stats_'.$table.' (id) VALUES ("'.$playerid.'")');
					}
					
					
					// Update the players stats
					if ($update) {
						$result = $this->update($playerid, $name, $platform);
						
						$this->sql->query('
							UPDATE `'.$this->sql->prefix.'player` SET
								`date_stats_update` = "'.time().'",
								`pushed`      = "'.$result['push'].'"
							WHERE `id` = "'.$playerid.'"
						');
					}
					
					
					// Generate message with $name in phrase
					$message = $this->tpl->phrase("message_add_player");
					eval ( "\$message = \"$message\";" );
					return $message;
				}
			}
		}
		
		
		public function delete($playerid = NULL, $name = "NoName") {
			if ($playerid === NULL) {
				return "ERROR: No Player-ID given";
			} else {
				$this->sql->query('DELETE FROM '.$this->sql->prefix.'player WHERE id = "'.$playerid.'"');
				$this->sql->query('DELETE FROM '.$this->sql->prefix.'stats__basic WHERE id = "'.$playerid.'"');
				$this->sql->query('DELETE FROM '.$this->sql->prefix.'stats__history WHERE playerid = "'.$playerid.'"');
				
				foreach ($this->tables as $table) {
					$this->sql->query('DELETE FROM '.$this->sql->prefix.'stats_'.$table.' WHERE id = "'.$playerid.'"');
				}
				
				$message = $this->tpl->phrase("message_delete_player");
				eval ( "\$message = \"$message\";" );
				return $message;
			}
		}
		
		
		public function update($playerid, $name, $platform) {
			### CALL STATS DATA ###
			$get = Array(
				'plat' => $platform,
				'name' => urlencode($name),
				'output' => 'json',
				'opt' => 'imagePaths,details,names,progress,extra,stats,weapons,weaponCategory,vehicles,vehicleCategory,kititems,awards,dogtags,assignments,urls'
			);
			
			$c=curl_init('http://api.bf4stats.com/api/playerInfo?plat='.$get['plat'].'&name='.$get['name'].'&opt='.$get['opt'].'&output=json');
			curl_setopt($c,CURLOPT_HEADER,false);
			curl_setopt($c,CURLOPT_CONNECTTIMEOUT, 5); 
			curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
			curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
			$result = json_decode(curl_exec($c));
			$statuscode = curl_getinfo($c,CURLINFO_HTTP_CODE);
			curl_close($c);
			
			
			
			if( $statuscode == 200) {
				### MANUAL DB-QUERIES ###
				if (true) {
					$this->sql->query('
						UPDATE `'.$this->sql->prefix.'stats__basic` SET
							`game`              = "'.$result->player->game.'",
							`plat`              = "'.$result->player->plat.'",
							`name`              = "'.$result->player->name.'",
							`tag`               = "'.$result->player->tag.'",
							`dateCheck`         = "'.substr(str_replace(Array(".", "E+12"), "", $result->player->dateCheck), 0, 10).'",
							`dateUpdate`        = "'.substr(str_replace(Array(".", "E+12"), "", $result->player->dateUpdate), 0, 10).'",
							`dateCreate`        = "'.substr(str_replace(Array(".", "E+12"), "", $result->player->dateCreate), 0, 10).'",
							`country`           = "'.$result->player->country.'",
							`countryName`       = "'.$result->player->countryName.'",
							`rank`              = "'.$this->func->convert_object($result->player->rank).'",
							`score`             = "'.$result->player->score.'",
							`timePlayed`        = "'.$result->player->timePlayed.'",
							`uId`               = "'.$result->player->uId.'",
							`uName`             = "'.$result->player->uName.'",
							`uGava`             = "'.$result->player->uGava.'",
							`udCreate`          = "'.substr(str_replace(Array(".", "E+12"), "", $result->player->udCreate), 0, 10).'"
						WHERE `id` = "'.$playerid.'"
					');
					
					$this->sql->query('
						UPDATE `'.$this->sql->prefix.'player` SET
							`date_stats_update` = "'.time().'",
							`api_player_status` = "OK"
						WHERE `id` = "'.$playerid.'"
					');
				}
				
				
				### AUTOMATIC DB-QUERIES ###
				foreach ($this->tables as $table) {
					if (is_object($result) AND isset($result->$table)) {
						$this->sql->query('
							REPLACE INTO `'.$this->sql->prefix.'stats_'.$table.'` (
								`id`, `data`
							) VALUES (
								'.$playerid.', "'.$this->func->convert_object($result->$table).'"
							)
						');
					}
				}
				
				
				### HISTORY DB-QUERIES ###
				if (true) {
					// Check for sufficient history entries for a chart every update as long as he has enough entries
					$this->sql->query('SELECT history_enough_data FROM '.$this->sql->prefix.'player WHERE id = "'.$playerid.'"');
					$history_enough_data = $this->sql->fetchRow("history_enough_data");
					
					if ($history_enough_data == "0") {
						$this->sql->query('SELECT id FROM '.$this->sql->prefix.'stats__history WHERE playerid = "'.$playerid.'"');
						
						// If there is enough data for a history chart, save this information into DB
						if ($this->sql->count() == $this->settings->get("functions_history_necessary_entries")) {
							$this->sql->query('UPDATE `'.$this->sql->prefix.'player` SET `history_enough_data` = "1" WHERE `id` = "'.$playerid.'"');
						}
					}
					
					
					// Get the last history entry of the player
					$this->sql->query('
						SELECT `date` 
						FROM '.$this->sql->prefix.'stats__history 
						WHERE playerid = "'.$playerid.'" 
						ORDER BY `date` DESC 
						LIMIT 0,1
					');
					
					if (!$this->sql->count()) {
						// No history entry so far -> save the history
						$save_history = true;
					} else {
						$time_last_entry      = $this->sql->fetchRow("date");
						$time_between_entries = $this->settings->get("functions_history_time_between_entries");
						
						if ($time_last_entry + $time_between_entries <= time()) {
							// Last entry is old enough -> save the history
							$save_history = true;
						} else {
							// Last entry is not old enough -> don't save the history
							$save_history = false;
						}
					}
					
					
					// Save the history
					if ($save_history) {
						// Create the entry
						$this->sql->query('
							INSERT INTO '.$this->sql->prefix.'stats__history 
								( `playerid`, `date` )
							VALUES
								( "'.$playerid.'", "'.time().'" )
						');
						$rowid = $this->sql->id;
						
						// Save the stats
						foreach ($this->history as $column) {
							$this->sql->query('
								UPDATE `'.$this->sql->prefix.'stats__history`
								SET `'.$column.'` = "'.$this->func->convert_object($result->$column).'"
								WHERE `id` = '.$rowid.'
							');
						}
						
						// Save the date of this update in players properties
						$this->sql->query('UPDATE `'.$this->sql->prefix.'player` SET `history_last_update` = "'.time().'" WHERE `id` = "'.$playerid.'"');
					}
				}
				
				
				### RANKING INFORMATIONS ###
				if (true) {
					$c=curl_init('http://api.bf4stats.com/api/playerRankings?plat='.$get['plat'].'&name='.$get['name'].'&output=json');
					curl_setopt($c,CURLOPT_HEADER,false);
					curl_setopt($c,CURLOPT_CONNECTTIMEOUT, 5); 
					curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
					curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
					$result = json_decode(curl_exec($c));
					$statuscode = curl_getinfo($c,CURLINFO_HTTP_CODE);
					curl_close($c);
					
					if( $statuscode == 200) {
						$this->sql->query('
							REPLACE INTO `'.$this->sql->prefix.'stats_rankings` (
								`id`, `data`
							) VALUES (
								'.$playerid.', "'.$this->func->convert_object($result).'"
							)
						');
					}
				}
				
				
				### RETURN OF THE RESULT ###
				$result = Array(
					'api_player_status'  => "OK",
					'update_left' => NULL,
					'push'        => "0"
				);
				return $result;
			}
			
			else {
				$status = (is_object($result) AND isset($result->error)) ? $result->error : "unknownError";
				
				$this->sql->query('
					UPDATE `'.$this->sql->prefix.'player` SET
						`date_stats_update` = "'.time().'",
						`api_player_status` = "'.$status.'"
					WHERE `id` = "'.$playerid.'"
				');
				
				$result = Array(
					'api_player_status'  => $status,
					'update_left' => NULL,
					'push'        => "0"
				);
				return $result;
			}
		}
		
		
		/*
		public function push_sync($name, $platform, $type) {
			$data = Array(
				'ident'  => $this->settings->get('properties_ident'),
				'time'   => time(),
				'type'   => $type,
				'player' => $name
			);
			
			$syncdata = $this->getAPIDataSigned('playerupdate', $platform, $data);
			
			if ($syncdata['status'] == 'error') {
				$syncdata['status'] = $syncdata['error'];
				$syncdata['update_left'] = '0';
			}
			
			$result = Array(
				'checkstate'  => $syncdata['status'],
				'update_left' => $syncdata['update_left'],
				'push'        => "1"
			);
			return $result;
		}
		
		
		
		// Fhrt einen signierten Request aus
		private function getAPIDataSigned($type, $platform, $data) {
			// Convert data to JSON
			$urlbase64 = array('+'=>'-','/'=>'_','='=>'');
			$data = strtr(base64_encode(json_encode($data)),$urlbase64);
			
			$postdata = Array(
				'data' => $data,
				'sig'  => strtr(base64_encode(hash_hmac('sha256', $data, $this->settings->get('properties_key'), true)),$urlbase64)
			);
			
			// Run POST Request via CURL
			$c=curl_init('http://api.bf3stats.com/'.$platform.'/'.$type.'/');
			curl_setopt($c,CURLOPT_HEADER,false);
			curl_setopt($c,CURLOPT_POST,true);
			curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1');
			curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
			curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
			$data=curl_exec($c);
			$statuscode=curl_getinfo($c,CURLINFO_HTTP_CODE);
			curl_close($c);
			
			if($statuscode==200) {
				// Decode JSON Data
				$data=json_decode($data,true);
				return $data;

			} else {
				echo "Stats API error status: ".$statuscode;
				return false;
			}
		}
		*/
	}
?>