<?php
	### LOAD CLASSES ###
	if (true) {
		require 'tmp/sql.php';
		require 'classes/mysql.php';
		
		$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
		
		require 'scripts/vendor/pqlite.php';
		require 'classes/settings.php';
		require 'classes/security.php';
		require 'classes/functions.php';
		require 'classes/template.php';
		require 'classes/player.php';
		require 'classes/stats.php';
		
		
		$func = new Functions();
		$secure = new Security();
		$settings = new Settings();
		$tpl = new Templates();
		$tpl->load_phrases("overview", true);
		$tpl->load_phrases("_bf4_overview", true);
		$tpl->load_phrases("detail", true);
		$tpl->load_phrases("_bf4_detail", true);
		$tpl->load_phrases("compare", true);
		$tpl->load_phrases("_bf4_compare", true);
		
		$plugin   = (int)$_GET['plugin'];
		$path     = ($plugin) ? $settings->get("properties_path") : "";
	}
	
	
	### FUNCTIONS ###
	// Function for creating cell- and tooltipp-HTML
	function row($result, $class="", $tooltip=false) {
		$class = ($class != "") ? ' class="'.$class.'"' : "";
		
		if (!$tooltip AND !isset($result['tip'])) {
			return '<td'.$class.' sort="'.$result['sort'].'">'.$result['format'].'</td>';
		} 
		
		else if (!$tooltip AND isset($result['tip'])) {
			return '<td'.$class.' sort="'.$result['sort'].'"><div title="'.strip_tags($result['tip']).'">'.$result['format'].'</div></td>';
		}
		
		else {
			return '<td'.$class.' sort="'.$result['sort'].'"><a href="'.$tooltip.'">'.$result['format'].'</a><div id="'.$tooltip.'" style="display: none">'.$result['tip'].'</div></td>';
		}
	}
	
	
	### SQL-Queries ###
	if (true) {
		// Load ID of any player (neccessary for info header)
		$sql->query('
			SELECT id
			FROM '.$sql->prefix.'stats__basic
			WHERE timePlayed != 0
			ORDER BY score DESC
			LIMIT 1
		');
		$row = $sql->fetchAssoc();
		$pid = $row['id'];
		
		
		// Load IDs of all players
		$sql->query('
			SELECT id
			FROM '.$sql->prefix.'stats__basic
			WHERE timePlayed != 0
			ORDER BY score DESC
		');
	}
	
	
	### WEAPONS ###
	if (isset($_GET['weapon'])) {
		// Weapon Information
		$weapon_informations = '{"ucav":{"name":"UCAV","img":"ucav","type":"Gadgets Explosives"},"338-recon":{"name":"338-RECON","img":"srs_338recon","type":"Sniper Rifles"},"as-val":{"name":"AS VAL","img":"asval","type":"PDWs"},"g36c":{"name":"G36C","img":"g36c","type":"Carbines"},"repair-tool":{"name":"REPAIR TOOL","img":"repairtool","type":"Special"},"xm25-smoke":{"name":"XM25 SMOKE","img":"xm25_smk","type":"Gadgets Explosives"},"hvm-ii":{"name":"HVM-II","img":"hvm_starstreak","type":"Rocket Launchers"},"mg4":{"name":"MG4","img":"mg4","type":"LMGs"},"lsat":{"name":"LSAT","img":"lsat","type":"LMGs"},"v40-mini":{"name":"V40 MINI","img":"v40_mini","type":"Hand Grenades"},"scar-h-sv":{"name":"SCAR-H SV","img":"scarhsv","type":"DMRs"},"f2000":{"name":"F2000","img":"f2000","type":"Assault Rifles"},"machete":{"name":"MACHETE","img":"machete","type":"Special"},"m40a5":{"name":"M40A5","img":"m40a5","type":"Sniper Rifles"},"fy-js":{"name":"FY-JS","img":"fyjs","type":"Sniper Rifles"},"c100":{"name":"C100","img":"c100","type":"Special"},"aek-971":{"name":"AEK-971","img":"aek971","type":"Assault Rifles"},"m26-mass":{"name":"M26 MASS","img":"m26mass","type":"Shotguns"},"cz-3a1":{"name":"CZ-3A1","img":"scorpion","type":"PDWs"},"scout-elite":{"name":"SCOUT ELITE","img":"scoutelite","type":"Sniper Rifles"},"bulldog":{"name":"BULLDOG","img":"bulldog","type":"Assault Rifles"},"a-91":{"name":"A-91","img":"a91","type":"Carbines"},"m82a3":{"name":"M82A3","img":"m82a3_far","type":"Sniper Rifles"},"aa-mine":{"name":"AA MINE","img":"aamine","type":"Gadgets Explosives"},"870-mcs":{"name":"870 MCS","img":"remington870","type":"Shotguns"},"amr-2-cqb":{"name":"AMR-2 CQB","img":"amr_cqb","type":"Sniper Rifles"},"groza-4":{"name":"GROZA-4","img":"groza4","type":"PDWs"},"shorty-12g":{"name":"SHORTY 12G","img":"shorty12g","type":"Shotguns"},"m18-smoke":{"name":"M18 SMOKE","img":"m18_smoke","type":"Hand Grenades"},"m84-flashbang":{"name":"M84 FLASHBANG","img":"m84_flashbang","type":"Hand Grenades"},"bayonet":{"name":"BAYONET","img":"knife","type":"Special"},"ump-9":{"name":"UMP-9","img":"ump9","type":"PDWs"},"srr-61":{"name":"SRR-61","img":"m200_srr61","type":"Sniper Rifles"},"hawk-12g":{"name":"HAWK 12G","img":"hawk12g","type":"Shotguns"},"bowie":{"name":"BOWIE","img":"knife_bowie","type":"Special"},"ace-23":{"name":"ACE 23","img":"galil_ace23","type":"Assault Rifles"},"m320-fb":{"name":"M320 FB","img":"m320_flash","type":"Underslung Launchers"},"m136-cs":{"name":"M136 CS","img":"m136","type":"Rocket Launchers"},"defibrillator":{"name":"DEFIBRILLATOR","img":"defib","type":"Special"},"mk153-smaw":{"name":"MK153 SMAW","img":"mk153_smaw","type":"Rocket Launchers"},"sks":{"name":"SKS","img":"sks","type":"DMRs"},"shank":{"name":"SHANK","img":"shank","type":"Special"},"pkp-pecheneg":{"name":"PKP PECHENEG","img":"pecheneg","type":"LMGs"},"qbu-88":{"name":"QBU-88","img":"qbu88","type":"DMRs"},"sg553":{"name":"SG553","img":"sg553lb","type":"Carbines"},"acb-90":{"name":"ACB-90","img":"knife_combat_acb90","type":"Special"},"sv-98":{"name":"SV-98","img":"sv98","type":"Sniper Rifles"},"precision":{"name":"PRECISION","img":"knife_precisionknife","type":"Special"},"deagle-44":{"name":"DEAGLE 44","img":"deserteagle","type":"Handguns"},"usas-12":{"name":"USAS-12","img":"usas12_bp","type":"Shotguns"},"seal":{"name":"SEAL","img":"knife_sealknife","type":"Special"},"carbon-fiber":{"name":"CARBON FIBER","img":"knife_carbon","type":"Special"},"weaver":{"name":"WEAVER","img":"knife_weaver","type":"Special"},"m1911":{"name":"M1911","img":"m1911","type":"Handguns"},"l96a1":{"name":"L96A1","img":"l96a1","type":"Sniper Rifles"},"m16a4":{"name":"M16A4","img":"m16a4","type":"Assault Rifles"},"44-magnum":{"name":".44 MAGNUM","img":"taurus44","type":"Handguns"},"m2-slam":{"name":"M2 SLAM","img":"m2_slam","type":"Gadgets Explosives"},"pdw-r":{"name":"PDW-R","img":"magpulpdr","type":"PDWs"},"m98b":{"name":"M98B","img":"m98b","type":"Sniper Rifles"},"rpg-7v2":{"name":"RPG-7V2","img":"rpg7","type":"Rocket Launchers"},"mx4":{"name":"MX4","img":"mx4","type":"PDWs"},"trench":{"name":"TRENCH","img":"knife_trench","type":"Special"},"ace-21-cqb":{"name":"ACE 21 CQB","img":"galil_ace21cqb","type":"Carbines"},"sw40":{"name":"SW40","img":"sw40","type":"Handguns"},"xm25-dart":{"name":"XM25 DART","img":"xm25_flc","type":"Gadgets Explosives"},"tactical":{"name":"TACTICAL","img":"knife_tactical2knife","type":"Special"},"m320-lvg":{"name":"M320 LVG","img":"m320_lvg","type":"Underslung Launchers"},"rgo-impact":{"name":"RGO IMPACT","img":"rgo_impact","type":"Hand Grenades"},"m15-at-mine":{"name":"M15 AT MINE","img":"at_mine","type":"Gadgets Explosives"},"pp-2000":{"name":"PP-2000","img":"pp2000","type":"PDWs"},"ak-12":{"name":"AK-12","img":"ak12","type":"Assault Rifles"},"svd-12":{"name":"SVD-12","img":"svd12","type":"DMRs"},"cz-75":{"name":"CZ-75","img":"cz75","type":"Handguns"},"cs5":{"name":"CS5","img":"cs5","type":"Sniper Rifles"},"js2":{"name":"JS2","img":"js2","type":"PDWs"},"survival":{"name":"SURVIVAL","img":"knife_survival","type":"Special"},"m224-mortar":{"name":"M224 MORTAR","img":"m224_mortar","type":"Gadgets Explosives"},"fim-92-stinger":{"name":"FIM-92 STINGER","img":"fim92_stinger","type":"Rocket Launchers"},"sr-2":{"name":"SR-2","img":"sr2","type":"PDWs"},"ak-5c":{"name":"AK 5C","img":"ak5c","type":"Carbines"},"ace-53-sv":{"name":"ACE 53 SV","img":"galil_ace53sv","type":"DMRs"},"mtar-21":{"name":"MTAR-21","img":"mtar21","type":"Carbines"},"m82a3-mid":{"name":"M82A3 MID","img":"m82a3_med","type":"Sniper Rifles"},"hand-flare":{"name":"HAND FLARE","img":"handflare","type":"Hand Grenades"},"m416":{"name":"M416","img":"m416","type":"Assault Rifles"},"m32-mgl":{"name":"M32 MGL","img":"mgl","type":"Gadgets Explosives"},"type-95b-1":{"name":"TYPE-95B-1","img":"type95b1","type":"Carbines"},"mbt-law":{"name":"MBT LAW","img":"mbt_law","type":"Rocket Launchers"},"jng-90":{"name":"JNG-90","img":"jng90","type":"Sniper Rifles"},"m412-rex":{"name":"M412 REX","img":"mp412rex","type":"Handguns"},"saiga-12k":{"name":"SAIGA 12K","img":"saiga12","type":"Shotguns"},"m82a3-cqb":{"name":"M82A3 CQB","img":"m82a3_cqb","type":"Sniper Rifles"},"l85a2":{"name":"L85A2","img":"l85a2","type":"Assault Rifles"},"spas-12":{"name":"SPAS-12","img":"spas12","type":"Shotguns"},"qbz-95-1":{"name":"QBZ-95-1","img":"qbz951","type":"Assault Rifles"},"tanto":{"name":"TANTO","img":"knife_tanto","type":"Special"},"neck":{"name":"NECK","img":"knife_neckknife","type":"Special"},"cz-805":{"name":"CZ-805","img":"cz805","type":"Assault Rifles"},"m320-he":{"name":"M320 HE","img":"m320","type":"Underslung Launchers"},"qbb-95-1":{"name":"QBB-95-1","img":"qbb95","type":"LMGs"},"m320-dart":{"name":"M320 DART","img":"m320_sg","type":"Underslung Launchers"},"ar160":{"name":"AR160","img":"ar160","type":"Assault Rifles"},"p226":{"name":"P226","img":"p226","type":"Handguns"},"m249":{"name":"M249","img":"m249","type":"LMGs"},"groza-1":{"name":"GROZA-1","img":"groza1","type":"Carbines"},"mp7":{"name":"MP7","img":"mp7","type":"PDWs"},"ace-52-cqb":{"name":"ACE 52 CQB","img":"galil_ace52cqb","type":"Carbines"},"aws":{"name":"AWS","img":"aws","type":"LMGs"},"type-88-lmg":{"name":"TYPE 88 LMG","img":"type88","type":"LMGs"},"improvised":{"name":"IMPROVISED","img":"knife_improvised","type":"Special"},"m4":{"name":"M4","img":"m4a1","type":"Carbines"},"fgm-148-javelin":{"name":"FGM-148 JAVELIN","img":"fgm148_javelin","type":"Rocket Launchers"},"boot":{"name":"BOOT","img":"knife_bootknife","type":"Special"},"acw-r":{"name":"ACW-R","img":"acwr","type":"Carbines"},"rpk-74m":{"name":"RPK-74M","img":"rpk74","type":"LMGs"},"rorsch-mk-1":{"name":"RORSCH MK-1","img":"railgun","type":"Gadgets Explosives"},"m39-emr":{"name":"M39 EMR","img":"m39","type":"DMRs"},"m67-frag":{"name":"M67 FRAG","img":"m67_grenade","type":"Hand Grenades"},"aug-a3":{"name":"AUG A3","img":"steyraug","type":"Assault Rifles"},"compact-45":{"name":"COMPACT 45","img":"hk45c","type":"Handguns"},"mare-s-leg":{"name":"MARES LEG","img":"saddlegun","type":"Handguns"},"u-100-mk5":{"name":"U-100 MK5","img":"ultimax","type":"LMGs"},"m60-e4":{"name":"M60-E4","img":"m60e4","type":"LMGs"},"cbj-ms":{"name":"CBJ-MS","img":"cbjms","type":"PDWs"},"unica-6":{"name":"UNICA 6","img":"unica6","type":"Handguns"},"mpx":{"name":"MPX","img":"mpx","type":"PDWs"},"scar-h":{"name":"SCAR-H","img":"scarh","type":"Assault Rifles"},"mk11-mod-0":{"name":"MK11 MOD 0","img":"mk11","type":"DMRs"},"dbv-12":{"name":"DBV-12","img":"dbv12","type":"Shotguns"},"m320-smk":{"name":"M320 SMK","img":"m320_smk","type":"Underslung Launchers"},"c4-explosive":{"name":"C4 EXPLOSIVE","img":"c4","type":"Gadgets Explosives"},"amr-2":{"name":"AMR-2","img":"amr_far","type":"Sniper Rifles"},"rpk-12":{"name":"RPK-12","img":"rpk12","type":"LMGs"},"cs-lr4":{"name":"CS-LR4","img":"cslr4","type":"Sniper Rifles"},"gol-magnum":{"name":"GOL Magnum","img":"gol","type":"Sniper Rifles"},"rfb":{"name":"RFB","img":"rfb","type":"DMRs"},"xm25-airburst":{"name":"XM25 AIRBURST","img":"xm25","type":"Gadgets Explosives"},"ump-45":{"name":"UMP-45","img":"ump","type":"PDWs"},"scout":{"name":"SCOUT","img":"knife_scout","type":"Special"},"eod-bot":{"name":"EOD BOT","img":"eodbot","type":"Special"},"m1014":{"name":"M1014","img":"m1014","type":"Shotguns"},"l86a2":{"name":"L86A2","img":"l86a1","type":"LMGs"},"usas-12-flir":{"name":"USAS-12 FLIR","img":"usas12_nv","type":"Shotguns"},"bj-2":{"name":"BJ-2","img":"knife_2142knife","type":"Special"},"g18":{"name":"G18","img":"glock18","type":"Handguns"},"aku-12":{"name":"AKU-12","img":"aku12","type":"Carbines"},"fn57":{"name":"FN57","img":"fn57","type":"Handguns"},"dao-12":{"name":"DAO-12","img":"dao12","type":"Shotguns"},"p90":{"name":"P90","img":"p90","type":"PDWs"},"qbs-09":{"name":"QBS-09","img":"qbs09","type":"Shotguns"},"an-94":{"name":"AN-94","img":"an94","type":"Assault Rifles"},"93r":{"name":"93R","img":"m93r","type":"Handguns"},"dive":{"name":"DIVE","img":"knife_diverknife","type":"Special"},"m320-3gl":{"name":"M320 3GL","img":"m320_3gl","type":"Underslung Launchers"},"m26-frag":{"name":"M26 FRAG","img":"m26mass_frg","type":"Shotguns"},"sr338":{"name":"SR338","img":"sr338","type":"Sniper Rifles"},"uts-15":{"name":"UTS 15","img":"utas","type":"Shotguns"},"m34-incendiary":{"name":"M34 INCENDIARY","img":"m34_incendiary","type":"Hand Grenades"},"sar-21":{"name":"SAR-21","img":"sar21","type":"Assault Rifles"},"m26-slug":{"name":"M26 SLUG","img":"m26mass_sg","type":"Shotguns"},"famas":{"name":"FAMAS","img":"famas","type":"Assault Rifles"},"mp443":{"name":"MP443","img":"mp443_grach","type":"Handguns"},"sa-18-igla":{"name":"SA-18 IGLA","img":"sa18_igla","type":"Rocket Launchers"},"m240b":{"name":"M240B","img":"m240","type":"LMGs"},"qsz-92":{"name":"QSZ-92","img":"qsz-92","type":"Handguns"},"amr-2-mid":{"name":"AMR-2 MID","img":"amr_med","type":"Sniper Rifles"},"fgm-172-sraw":{"name":"FGM-172 SRAW","img":"fgm172_sraw","type":"Rocket Launchers"},"m26-dart":{"name":"M26 DART","img":"m26mass_flc","type":"Shotguns"},"m18-claymore":{"name":"M18 CLAYMORE","img":"claymore","type":"Gadgets Explosives"},"m9":{"name":"M9","img":"m9","type":"Handguns"},"ballistic-shield":{"name":"BALLISTIC SHIELD","img":"shield","type":"Special"}}';
		$w = json_decode($weapon_informations);
		
		$wid     = preg_replace('/[^a-zA-Z0-9\-]/', '', $_GET['weapon']); // Replaces all characters except signs, numbers and hyphen
		$name    = $w->$wid->name;
		$img_src = $path.'styles/icons/weapons/'.$w->$wid->img.'.png';
		$type    = $w->$wid->type;
		
		
		// Load template
		eval ("\$html = \"".$tpl->template("compare_weapons")."\";");  
		$html = new PQLite($html);
		$i = 0;
		
		
		// Load stats of players for this weapon
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				$weapons = $stats->get('weapons');
				$weapCat = $stats->get('weaponCategory');
				
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name,
				), "tleft");
				
				
				// Load the data of the actual weapon into var $weapon
				$weapon = false;
				foreach ($weapons as $w) {
					if ($w->detail->id == $wid) $weapon = $w;
				}
				
				// The player hasn't this weapon
				if (!$weapon) {
					$td['stars'] = '<td sort="0"></td>';
					$td['time'] = '<td sort="0">0</td>';
					$td['kills'] = '<td sort="0">0</td>';
					$td['kpm'] = '<td sort="0">0</td>';
					$td['kip'] = '<td sort="0">0</td>';
					$td['hs'] = '<td sort="0">0</td>';
					$td['hsp'] = '<td sort="0">0</td>';
					$td['shotspm'] = '<td sort="0">0</td>';
					$td['acc'] = '<td sort="0">0</td>';
				}
				
				// The player has this weapon
				else {
					// Get the count of kills in the category of the weapon
					$kills_in_category = 0;
					foreach ($weapCat as $c) {
						if ($c->name == $weapon->detail->category) $kills_in_category = $c->stat->kills;
					}
					
					
					$td['stars'] = row(Array(
						'format' => '<div class="ezSstar" style="'.($weapon->stars->count ? '' : 'opacity: 0.5').'">'.$weapon->stars->count.'</div>',
						'tip' =>    $tpl->phrase('star').': '.$weapon->stars->count.' - '.$tpl->phrase('star_kills_left').': '.($weapon->stars->needed - $weapon->stars->curr),
						'sort' =>   $weapon->stat->kills,
					), "tcenter");
					
					
					$td['time'] = row($stats->form($weapon->stat->time, Array('time', 0, 'dynamic'), false));
					
					
					$td['kills'] = row($stats->form($weapon->stat->kills, Array('number', 0, '', "kills"), false));
					
					
					$result = $stats->form($weapon->stat->kills, Array('ratio', ($weapon->stat->time / 60), 2), false);
					$td['kpm'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('kills_per_minute').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->kills, Array('ratio', $kills_in_category, 0, '%'), false);
					$td['kip'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('label_killp').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->hs, Array('number'));
					$td['hs'] = row(Array(
						'format' => $result,
						'tip' =>    $tpl->phrase('headshots').': '.$result,
						'sort' =>   $weapon->stat->hs,
					));
					
					
					$result = $stats->form($weapon->stat->hs, Array('ratio', $weapon->stat->kills, 0, '%'), false);
					$td['hsp'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('headshots').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->shots, Array('ratio', ($weapon->stat->time / 60)), false);
					$td['shotspm'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('label_shots_per_minute').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->hits, Array('ratio', $weapon->stat->shots, 0, '%'), false);
					$td['acc'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('accuracy').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
				}
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### WEAPON CATEGORY ###
	if (isset($_GET['weaponCategory'])) {
		$tbody = "";
		$headline = NULL;
		
		// Load stats of players
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				$weaponCategory = $stats->get('weaponCategory');
				$cat = NULL;
				
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				
				
				$kills_in_category = 0;
				foreach ($weaponCategory as $c) {
					$kills_in_category += $c->stat->kills;
					if ($_GET['weaponCategory'] == str_replace(' ', '', $c->name)) $cat = $c;
				}
				
				if (!$headline) $headline = $cat->name;
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name
				), "tleft");
				
				
				$td['time'] = row($stats->form($cat->stat->time, Array('time', 0, 'dynamic'), false));
				
				
				$td['kills'] = row($stats->form($cat->stat->kills, Array('number', 0, '', "kills"), false));
				
				
				$result = $stats->form($cat->stat->kills, Array('ratio', ($cat->stat->time / 60), 2), false);
				$td['kpm'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('kills_per_minute').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($cat->stat->kills, Array('ratio', $kills_in_category, 0, '%'), false);
				$td['kip'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_killp_wpcat').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($cat->stat->hs, Array('number'));
				$td['hs'] = row(Array(
					'format' => $result,
					'tip' =>    $tpl->phrase('headshots').': '.$result,
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($cat->stat->hs, Array('ratio', $cat->stat->kills, 0, '%'), false);
				$td['hsp'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('headshots').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($cat->stat->shots, Array('ratio', ($cat->stat->time / 60)), false);
				$td['shotspm'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_shots_per_minute').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($cat->stat->hits, Array('ratio', $cat->stat->shots, 0, '%'), false);
				$td['acc'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('accuracy').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$tbody .= '<tr>'.implode('', $td).'</tr>';
			}
		}
		
		
		// Load template
		eval ("\$html = \"".$tpl->template("compare_weapon_category")."\";");  
		$html = new PQLite($html);
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### VEHICLES ###
	if (isset($_GET['vehicle'])) {
		// Vehicle Information
		$vehicle_informations = '{"zbd-09":{"name":"ZBD-09","img":"zbd09","type":"Vehicle Infantry Fighting Vehicle"},"lav-ad":{"name":"LAV-AD","img":"lav-ad","type":"Vehicle Anti Air"},"launch-pod":{"name":"LAUNCH POD","img":"pod","type":"Vehicle Transport"},"type-95-aa":{"name":"TYPE 95 AA","img":"type95aa","type":"Vehicle Anti Air"},"j-20":{"name":"J-20","img":"j20","type":"Vehicle Air Jet Stealth"},"q-5-fantan":{"name":"Q-5 FANTAN","img":"q5","type":"Vehicle Air Jet Attack"},"9m133-kornet-launcher":{"name":"9M133 KORNET LAUNCHER","img":"kornet","type":"Weapon Stationary "},"lav-25":{"name":"LAV-25","img":"lav-25","type":"Vehicle Infantry Fighting Vehicle"},"old-cannon":{"name":"OLD CANNON","img":"oldcannon","type":"Weapon Stationary "},"dirtbike":{"name":"DIRTBIKE","img":"dirtbike","type":"Vehicle Transport"},"ka-60-kasatka":{"name":"KA-60 KASATKA","img":"ka60","type":"Vehicle Transport"},"rhib-boat":{"name":"RHIB BOAT","img":"rhib","type":"Vehicle Boat"},"bomber":{"name":"BOMBER","img":"h6k","type":"Vehicle Air"},"ld-2000-aa":{"name":"LD-2000 AA","img":"ld-2000","type":"Weapon Stationary AA"},"m1-abrams":{"name":"M1 ABRAMS","img":"m1a2","type":"Vehicle Main Battle Tanks"},"ah-6j-little-bird":{"name":"AH-6J LITTLE BIRD","img":"ah6","type":"Vehicle Air Helicopter Scout"},"mi-28-havoc":{"name":"Mi-28 HAVOC","img":"mi28","type":"Vehicle Air Helicopter Attack"},"m142":{"name":"M142","img":"himars","type":"Vehicle Mobile Artillery"},"a10-warthog":{"name":"A10 WARTHOG","img":"a10","type":"Vehicle Air Jet Attack"},"z-11w":{"name":"Z-11W","img":"z11","type":"Vehicle Air Helicopter Scout"},"t-90a":{"name":"T-90A","img":"t90","type":"Vehicle Main Battle Tanks"},"snowmobile":{"name":"SNOWMOBILE","img":"snowmobile","type":"Vehicle Transport"},"ucav1":{"name":"UCAV","img":"ucav","type":"Soldier Equiment"},"spm-3":{"name":"SPM-3","img":"spm3","type":"Vehicle Transport"},"ah-1z-viper":{"name":"AH-1Z VIPER","img":"ah1z","type":"Vehicle Air Helicopter Attack"},"eod-bot1":{"name":"EOD BOT","img":"eodbot","type":"Soldier Equiment"},"dv-15":{"name":"DV-15","img":"dv15","type":"Vehicle Fast Attack Craft"},"dpv":{"name":"DPV","img":"dpv","type":"Vehicle Transport"},"f35":{"name":"F35","img":"f35","type":"Vehicle Air Jet Stealth"},"type-99-mbt":{"name":"TYPE 99 MBT","img":"type99mbt","type":"Vehicle Main Battle Tanks"},"hj-8-launcher1":{"name":"HJ-8 LAUNCHER","img":"hj8","type":"Weapon Stationary "},"schipunov-42":{"name":"SCHIPUNOV 42","img":"sc42","type":"Weapon Stationary "},"ac-130-gunship":{"name":"AC-130 GUNSHIP","img":"ac130","type":"Vehicle Air"},"rcb":{"name":"RCB","img":"rcb90","type":"Vehicle Fast Attack Craft"},"aav-7a1-amtrac":{"name":"AAV-7A1 AMTRAC","img":"aav","type":"Vehicle Transport"},"ht-95-levkov":{"name":"HT-95 LEVKOV","img":"ht95","type":"Vehicle Main Battle Tanks"},"zfb-05":{"name":"ZFB-05","img":"zfb05","type":"Vehicle Transport"},"pantsir-s1":{"name":"PANTSIR-S1","img":"pantsir","type":"Weapon Stationary AA"},"m1161-itv":{"name":"M1161 ITV","img":"growler","type":"Vehicle Transport"},"rawr":{"name":"RAWR","img":"rawr","type":"Soldier Equiment"},"z-10w":{"name":"Z-10W","img":"z10w","type":"Vehicle Air Helicopter Attack"},"50-cal":{"name":".50 CAL","img":"gunshield","type":"Weapon Stationary "},"su-25tm-frogfoot":{"name":"SU-25TM FROGFOOT","img":"su25","type":"Vehicle Air Jet Attack"},"uh-1y-venom":{"name":"UH-1Y VENOM","img":"venom","type":"Vehicle Transport"},"xd-1-accipiter":{"name":"XD-1 Accipiter","img":"xd1","type":"Soldier Equiment"},"vdv-buggy":{"name":"VDV BUGGY","img":"vdv","type":"Vehicle Transport"},"quad-bike":{"name":"QUAD BIKE","img":"quadbike","type":"Vehicle Transport"},"lyt2021":{"name":"LYT2021","img":"lyt2021","type":"Vehicle Transport"},"z-11w1":{"name":"Z-11W","img":"z11","type":"Vehicle Air Helicopter Scout"},"mrap":{"name":"MRAP","img":"mrap-cougar","type":"Vehicle Transport"},"btr-90":{"name":"BTR-90","img":"btr90","type":"Vehicle Infantry Fighting Vehicle"},"hj-8-launcher":{"name":"HJ-8 LAUNCHER","img":"centurion","type":"Weapon Stationary AA"},"z-9-haitun":{"name":"Z-9 HAITUN","img":"z9-haitun","type":"Vehicle Transport"},"acv":{"name":"ACV","img":"acv","type":"Vehicle Transport"},"suav":{"name":"SUAV","img":"suav","type":"Soldier Equiment"},"aa-mine1":{"name":"AA MINE","img":"aamine","type":"Soldier Equiment"},"m224-mortar1":{"name":"M224 MORTAR","img":"m224_mortar","type":"Soldier Equiment"},"m220-tow-launcher":{"name":"M220 TOW LAUNCHER","img":"tow","type":"Weapon Stationary "},"pwc":{"name":"PWC","img":"pwc-jetski","type":"Vehicle Transport"},"skid-loader":{"name":"SKID LOADER","img":"skidloader","type":"Vehicle Transport"},"mav":{"name":"MAV","img":"mav","type":"Soldier Equiment"},"9k22-tunguska-m":{"name":"9K22 TUNGUSKA-M","img":"tunguska","type":"Vehicle Anti Air"},"su-50":{"name":"SU-50","img":"su50-t50pak","type":"Vehicle Air Jet Stealth"}}';
		$v = json_decode($vehicle_informations);
		
		$vid     = preg_replace('/[^a-zA-Z0-9\-]/', '', $_GET['vehicle']); // Replaces all characters except signs, numbers and hyphen
		$name    = $v->$vid->name;
		$img_src = $path.'styles/icons/vehicles/'.$v->$vid->img.'.png';
		$type    = $v->$vid->type;
		
		
		// Load template
		eval ("\$html = \"".$tpl->template("compare_vehicles")."\";");  
		$html = new PQLite($html);
		$i = 0;
		
		
		// Load stats of players for this weapon
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				$vehicles = $stats->get('vehicles');
				
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name,
				), "tleft");
				
				
				// Load the data of the actual vehicle into var $vehicle
				$vehicle = false;
				foreach ($vehicles as $v) {
					if ($v->detail->id == $vid) $vehicle = $v;
				}
				
				// The player hasn't this vehicle
				if (!$vehicle) {
					$td['kills'] = '<td sort="0">0</td>';
					$td['time'] = '<td sort="0">0</td>';
					$td['kpm'] = '<td sort="0">0</td>';
					$td['destroys'] = '<td sort="0">0</td>';
					$td['dpm'] = '<td sort="0">0</td>';
				}
				
				// The player has this vehicle
				else {
					$td['kills']    = row($stats->form($vehicle->stat->kills, Array('number', 0, '', "kills"), false));
					$td['time']     = row($stats->form($vehicle->stat->time, Array('time', 0, 'dynamic'), false));
					$td['kpm']      = row($stats->form($vehicle->stat->kills, Array('ratio', ($vehicle->stat->time / 60), 2, '', 'kpm'), false));
					$td['destroys'] = row($stats->form($vehicle->stat->destroys, Array('number', 0, '', "destroys"), false));
					$td['dpm']      = row($stats->form($vehicle->stat->destroys, Array('ratio', ($vehicle->stat->time / 60), 2, '', 'dpm'), false));
				
				}
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### VEHICLE CATEGORY ###
	if (isset($_GET['vehicleCategory'])) {
		$tbody = "";
		$headline = NULL;
		
		
		// Load stats of players for this vehicle
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				$vehicleCategory = $stats->get('vehicleCategory');
				$cat = NULL;
				
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				
				
				$kills_in_category = 0;
				foreach ($vehicleCategory as $c) {
					$kills_in_category += $c->stat->kills;
					if ($_GET['vehicleCategory'] == $c->id) $cat = $c;
				}
				
				if (!$headline) $headline = $tpl->phrase($cat->id);
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name,
				), "tleft");
				
				
				$td['kills'] = row($stats->form($cat->stat->kills, Array('number', 0, '', "kills"), false));
				
				$td['time'] = row($stats->form($cat->stat->time, Array('time', 0, 'dynamic'), false));
				
				$td['kpm'] = row($stats->form($cat->stat->kills, Array('ratio', ($cat->stat->time / 60), 2, '', 'kpm'), false));
				
				$result = $stats->form($cat->stat->kills, Array('ratio', $kills_in_category, 0, '%'), false);
				$td['kip'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_killp_vehcat').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				$td['destroys'] = row($stats->form($cat->stat->destroys, Array('number', 0, '', "destroys"), false));
				
				$td['dpm'] = row($stats->form($cat->stat->destroys, Array('ratio', ($cat->stat->time / 60), 2, '', 'dpm'), false));
				
				
				$tbody .= '<tr>'.implode('', $td).'</tr>';
			}
		}
		
		
		// Load template
		eval ("\$html = \"".$tpl->template("compare_vehicle_category")."\";");  
		$html = new PQLite($html);
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### KITS ###
	if (isset($_GET['kits'])) {
		// Load template
		eval ("\$html = \"".$tpl->template("compare_kits")."\";");  
		$html = new PQLite($html);
		
		
		// Load stats of players
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				$kits = $stats->get('stats', 'kits');
				$kit = preg_replace('/[^a-zA-Z0-9\-]/', '', $_GET['kits']); // Replaces all characters except signs, numbers and hyphen
				$kit = $kits->$kit;
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name
				), "tleft");
				
				
				
				$td['stars'] = row(Array(
					'format' => '<div class="ezSstar" style="'.($kit->stars ? '' : 'opacity: 0.5').'">'.$kit->stars.'</div>',
					'tip' =>    $tpl->phrase('star').': '.$kit->stars,
					'sort' =>   $kit->score
				), "tcenter");
				
				
				$td['score'] = row($stats->form($kit->score, Array('number', 0, '', 'score'), false));
				
				$td['time'] = row($stats->form($kit->time, Array('time', 1, 'h'), false));
				
				$td['spm'] = row($stats->form($kit->score, Array('ratio', ($kit->time/60), 0, '', 'spm'), false));
				
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		
		// Page output
		die ($html->getHTML());
	}
	
	### COMBAT ###
	if (isset($_GET['common']) AND $_GET['common'] == "combat") {
		// Load template
		eval ("\$html = \"".$tpl->template("compare_combat")."\";");  
		$html = new PQLite($html);
		
		
		// Load stats of players
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				$time     = $stats->get('stats', 'timePlayed') / 60;
				
				$awards = $stats->get('awards');
				foreach ($awards as $award) {
					if ($award->id == "m09") $mvp = $award->rCount;
				}
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name
				), "tleft");
				
				
				$td['skill'] = row(Array(
					'format' => $stats->get('stats', 'skill'),
					'tip' =>    $tpl->phrase('skill').': '.$stats->get('stats', 'skill'),
					'sort' =>   $stats->get('stats', 'skill')
				));
				
				
				$td['spm'] = row($stats->get('basic', 'score', Array('ratio', $time, 0, '', 'spm'), false));
				
				
				$result = $stats->form($mvp, Array('ratio', $stats->get('stats', 'numRounds'), 1, '%'), false);
				$td['mvp'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_mvp').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$td['kpm'] = row($stats->get('stats', 'kills', Array('ratio', $time, 2, '', 'kpm'), false));
				
				$td['kdr'] = row($stats->get('stats', 'kills', Array('ratio', $stats->get('stats', 'deaths'), 2, '', 'kdr'), false));
				
				$td['stk'] = row(Array(
					'format' => $stats->get('stats', 'killStreakBonus'),
					'tip' =>    $tpl->phrase('killstreakbonus').': '.$stats->get('stats', 'killStreakBonus'),
					'sort' =>   $stats->get('stats', 'killStreakBonus')
				));
				
				$td['nem'] = row(Array(
					'format' => $stats->get('stats', 'nemesisStreak'),
					'tip' =>    $tpl->phrase('nemesisstreak').': '.$stats->get('stats', 'nemesisStreak'),
					'sort' =>   $stats->get('stats', 'nemesisStreak')
				));
				
				$result = $stats->get('stats', 'headshots', Array('ratio', $stats->get('stats', 'kills'), 1, '%'));
				$td['hsp'] = row(Array(
					'format' => $result,
					'tip' =>    $tpl->phrase('headshots').' (%): '.$result,
					'sort' =>   $result
				));
				
				$td['hsl'] = row(Array(
					'format' => $stats->get('stats', 'longestHeadshot', Array('number', 0, 'm')),
					'tip' =>    $tpl->phrase('headshdist').': '.$stats->get('stats', 'longestHeadshot').'m',
					'sort' =>   $stats->get('stats', 'longestHeadshot')
				));
				
				$result = $stats->get('stats', 'shotsHit', Array('ratio', $stats->get('stats', 'shotsFired'), 1, '%'));
				$td['acc'] = row(Array(
					'format' => $result,
					'tip' =>    $tpl->phrase('accuracy').': '.$result,
					'sort' =>   $result
				));
				
				$td['wlr'] = row($stats->get('stats', 'numWins', Array('ratio', $stats->get('stats', 'numLosses'), 2, '', 'wlr'), false));
				
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### TEAMPLAY ###
	if (isset($_GET['common']) AND $_GET['common'] == "teamplay") {
		// Load template
		eval ("\$html = \"".$tpl->template("compare_teamplay")."\";");  
		$html = new PQLite($html);
		
		
		// Load stats of players
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				$time     = $stats->get('stats', 'timePlayed') / 60;
				
				$awards = $stats->get('awards');
				foreach ($awards as $award) {
					if ($award->id == "m07") $spot = $award->rCount * 4;
					if ($award->id == "m08") $ace = $award->rCount;
				}
				foreach ($stats->get('stats', 'modes') as $mode) {
					if ($mode->name == "Conquest") $cq = $mode->score;
					if ($mode->name == "Domination") $dom = $mode->score;
				}
				foreach ($stats->get('stats', 'kits') as $kit) {
					if ($kit->name == "Assault")  $assault = $kit->time / 60;
					if ($kit->name == "Engineer") $engineer = $kit->time / 60;
					if ($kit->name == "Support")  $support = $kit->time / 60;
				}
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name
				), "tleft");
				
				
				$result = $stats->form($ace, Array('ratio', $stats->get('stats', 'numRounds'), 1, '%'), false);
				$td['ace'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_ace').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$flagScore = $stats->get('stats', 'flagDefend') + $stats->get('stats', 'flagCaptures');
				$modeScore = $cq + $dom;
				$result = $stats->form($flagScore * 1000, Array('ratio', $modeScore, 2), false);
				$td['flg'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_flag').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->get('stats', 'heals', Array('ratio', $assault, 2), false);
				$td['hea'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_heals').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->get('stats', 'revives', Array('ratio', $assault, 2), false);
				$td['rev'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_revives').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->get('stats', 'repairs', Array('ratio', $engineer, 2), false);
				$td['rep'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_repairs').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->get('stats', 'resupplies', Array('ratio', $support, 2), false);
				$td['res'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_resupplies').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$result = $stats->form($spot, Array('ratio', $stats->get('stats', 'numRounds'), 2), false);
				$td['spo'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_spot').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$val = ($stats->get('stats', 'numWins') + $stats->get('stats', 'numLosses') - $stats->get('stats', 'numRounds')) * -1;
				$result = $stats->form($val, Array('ratio', $stats->get('stats', 'numRounds'), 1, '%'), false);
				$td['qui'] = row(Array(
					'format' => $result['format'],
					'tip' =>    $tpl->phrase('label_quits').': '.$result['format'],
					'sort' =>   $result['sort']
				));
				
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		
		// Page output
		die ($html->getHTML());
	}
	
	
	### FAVOURITES ###
	if (isset($_GET['favourites'])) {
		// Load template
		eval ("\$html = \"".$tpl->template("compare_favourites")."\";");  
		$html = new PQLite($html);
		
		
		// Load stats of players
		if (true) {
			while ($pid = $sql->fetchRow('id')) {
				$td = Array();
				$stats = new Stats($pid);
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$plat     = $stats->get('basic', 'plat');
				$rank     = $stats->get('basic', 'rank');
				$time     = $stats->get('stats', 'timePlayed') / 60;
				$opt      = $settings->get('features_rankicon');
				$size = Array(
					'tiny' => 32,
					'small' => 48,
					'medium' => 64,
					'large' => 128
				);
				
				
				$td['rank'] = row(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tleft");
				
				
				$td['name'] = row(Array(
					'format' => '<a href="http://bf4stats.com/'.$plat.'/'.$name.'" target="_blank">'.$clantag.$nname.'</a>',
					'sort' =>   $name
				), "tleft");
				
				
				// Kits
				if (true) {
					$kits   = $stats->get('stats', 'kits');
					$img    = $path.'styles/icons/kits/'.$opt.'.png';
					$array  = Array();
					
					foreach ($kits as $name => $obj) {
						$array[$obj->time] = $name;
					}
					ksort($array);
					$result = array_pop($array);
					
					$offset = Array(
						"assault" => 0,
						"engineer" => 1 * $size[$opt],
						"support" => 2 * $size[$opt],
						"recon" => 3 * $size[$opt],
						"commander" => 4 * $size[$opt]
					);
					
					
					$y = $offset[$result];
					$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
					$tip = $tpl->phrase('label_kit').': '.$kits->$result->name.' ('.$stats->form($kits->$result->time, Array('time', 0, 'h')).' / '.$stats->form($kits->$result->score, Array('ratio', ($kits->$result->time/60))).' SPM)';
					
					$td['kit']  = row(Array(
						'format' => $div,
						'tip' =>    $tip,
						'sort' =>   $result
					), "tcenter");
				}
				
				
				// Gamemode
				if (true) {
					$modes   = $stats->get('stats', 'modes');
					$img    = $path.'styles/icons/modes/'.$opt.'.png';
					$sum    = 0;
					$array  = Array();
					
					foreach ($modes as $key => $obj) {
						$sum += $obj->score;
						$array[$obj->score] = $key;
					}
					ksort($array);
					$result = array_pop($array);
					
					$offset = Array(
						"Conquest" => 0,
						"Rush" => 32,
						"Deathmatch" => 64,
						"Domination" => 96,
						"Obliteration" => 128,
						"Defuse" => 160
					);
					
					
					$y = $offset[$modes[$result]->name];
					$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
					$tip = $tpl->phrase('label_gamemode').': '.$modes[$result]->name.' ('.$stats->form($modes[$result]->score, Array('ratio', $sum, 0, '%')).' '.$tpl->phrase('achieved_score').')';
					
					$td['mode']  = row(Array(
						'format' => $div,
						'tip' =>    $tip,
						'sort' =>   $result
					), "tcenter");
				}
				
				
				// Vehcats
				if (true) {
					$vehcats = $stats->get('vehicleCategory');
					$img     = $path.'styles/icons/vehcats/'.$opt.'.png';
					$array   = Array();
					$vehcats_offset = array_flip(Array('Infantry Fighting Vehicle', 'Anti Air', 'Air Jet Stealth', 'Air Jet Attack', 'Weapon Stationary', 'Main Battle Tanks', 'Transport', 'Air Helicopter Attack', 'Air Helicopter Scout', 'Fast Attack Craft', 'Soldier Equiment', 'Boat', 'Mobile Artillery', 'Air', 'Weapon Stationary AA'));
					
					foreach ($vehcats as $obj) {
						$array[$obj->stat->time] = $obj->name;
					}
					ksort($array);
					$result = array_pop($array);
					
					foreach ($vehcats as $obj) {
						if ($obj->name == $result) $vehcat = $obj;
					}
					
					
					$y = $vehcats_offset[trim($result)] * $size[$opt];
					$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
					$tip = $tpl->phrase('label_vehcat').': '.$vehcat->name.' ('.$stats->form($vehcat->stat->time, Array('time', 0, 'h')).' / '.$stats->form($vehcat->stat->kills, Array('ratio', ($vehcat->stat->time/60), 2)).' KPM)';
					
					
					$td['vec']= row(Array(
						'format' => $div,
						'tip' =>    $tip,
						'sort' =>   $result
					), "tcenter");
				}
				
				
				// Vehicles
				if (true) {
					$vehicles = $stats->get('vehicles');
					$array  = Array();
					
					foreach ($vehicles as $key => $obj) {
						$array[$obj->stat->kills] = $key;
					}
					ksort($array);
					$result = array_pop($array);
					
					$tip = $tpl->phrase('label_vehicle').': '.$vehicles[$result]->name.' ('.$vehicles[$result]->detail->category.') ('.$stats->form($vehicles[$result]->stat->kills, Array('number')).' Kills / '.$stats->form($vehicles[$result]->stat->kills, Array('ratio', ($vehicles[$result]->stat->time/60), 2)).' KPM)';
					
					
					$td['veh'] = row(Array(
						'format' => $vehicles[$result]->name,
						'tip' =>    $tip,
						'sort' =>   $vehicles[$result]->name
					), "tleft");
				}
				
				
				// Weapcats
				if (true) {
					$weapons = $stats->get('weapons');
					$img     = $path.'styles/icons/weapcats/'.$opt.'.png';
					$weapcats_sort = Array ('SNIPER RIFLE' => 0, 'CARBINE' => 0, 'GADGET' => 0, 'BATTLE PICKUP' => 0, 'LMG' => 0, 'GRENADE' => 0, 'DMR' => 0, 'ASSAULT RIFLE' => 0, 'PDW' => 0, 'KNIFE' => 0, 'SHOTGUN' => 0, 'SIDEARM' => 0);
					$weapcats_offset = array_flip(Array('SNIPER RIFLE', 'CARBINE', 'GADGET', 'BATTLE PICKUP', 'LMG', 'GRENADE', 'DMR', 'ASSAULT RIFLE', 'PDW', 'KNIFE', 'SHOTGUN', 'SIDEARM'));
					$wkills = 0; $wtime = 0;
					
					foreach ($weapons as $key => $weapon) {
						$weapcats_sort[$weapon->detail->category] += $weapon->stat->kills;
					}
					$weapcats_sort = array_flip($weapcats_sort);
					ksort($weapcats_sort);
					$result = array_pop($weapcats_sort);
					
					foreach ($weapons as $key => $weapon) {
						if ($weapon->detail->category == $result) {
							$wkills += $weapon->stat->kills;
							$wtime += $weapon->stat->time;
						}
					}
					
					$y = $weapcats_offset[trim($result)] * $size[$opt];
					$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
					$tip = $tpl->phrase('label_weapcat').': '.$result.' ('.$stats->form($wkills, Array('number')).' Kills / '.$stats->form($wkills, Array('ratio', ($wtime/60), 2)).' KPM)';
					
					
					$td['wec']= row(Array(
						'format' => $div,
						'tip' =>    $tip,
						'sort' =>   $result
					), "tcenter");
				}
				
				
				// Weapons
				if (true) {
					$weapons = $stats->get('weapons');
					$array  = Array();
					
					foreach ($weapons as $key => $obj) {
						$array[$obj->stat->kills] = $key;
					}
					ksort($array);
					$result = array_pop($array);
					
					$tip = $tpl->phrase('label_weapon').': '.$weapons[$result]->name.' ('.$weapons[$result]->detail->type.') ('.$stats->form($weapons[$result]->stat->kills, Array('number')).' Kills / '.$stats->form($weapons[$result]->stat->kills, Array('ratio', ($weapons[$result]->stat->time/60), 2)).' KPM)';
					
					
					$td['wea'] = row(Array(
						'format' => $weapons[$result]->name,
						'tip' =>    $tip,
						'sort' =>   $weapons[$result]->name
					), "tleft");
				}
				
				
				$html->find('#ezContent tbody')->appendHTML('<tr>'.implode('', $td).'</tr>');
			}
		}
		
		
		// Page output
		die ($html->getHTML());
	}
	
?>