<?php
	### LOAD CLASSES ###
	if (true) {
		require 'tmp/sql.php';
		require 'classes/mysql.php';
		
		$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
		
		require 'scripts/vendor/pqlite.php';
		require 'classes/settings.php';
		require 'classes/security.php';
		require 'classes/functions.php';
		require 'classes/template.php';
		require 'classes/player.php';
		require 'classes/stats.php';
		require 'classes/signatures.php';
		
		
		$func = new Functions();
		$secure = new Security();
		$settings = new Settings();
		$tpl = new Templates();
		$tpl->load_phrases("overview", true);
		$tpl->load_phrases("_bf4_overview", true);
		$tpl->load_phrases("detail", true);
		$tpl->load_phrases("_bf4_detail", true);
	}
	
	
	### SET COMMOM VARIABLES ###
	if (true) {
		$playerid = (int)$_GET['pid'];
		$plugin   = (int)$_GET['plugin'];
		$path     = ($plugin) ? $settings->get("properties_path") : "";
		date_default_timezone_set($settings->get("settings_timezone"));
		
		$action = (isset($_GET['action'])) ? $_GET['action'] : "default";
	}
	
	
	### FUNCTIONS ###
	// Function for creating cell- and tooltipp-HTML
	function row($result, $class="", $tooltip=false) {
		$class = ($class != "") ? ' class="'.$class.'"' : "";
		
		if (!$tooltip AND !isset($result['tip'])) {
			return '<td'.$class.' sort="'.$result['sort'].'">'.$result['format'].'</td>';
		} 
		
		else if (!$tooltip AND isset($result['tip'])) {
			return '<td'.$class.' sort="'.$result['sort'].'"><div title="'.strip_tags($result['tip']).'">'.$result['format'].'</div></td>';
		}
		
		else {
			return '<td'.$class.' sort="'.$result['sort'].'"><a href="'.$tooltip.'">'.$result['format'].'</a><div id="'.$tooltip.'" style="display: none">'.$result['tip'].'</div></td>';
		}
	}
	
	// Function for creating ranking info
	function ranking($name_of_ranking, $cell_array=false) {
		global $playerid, $tpl;
		$stats = new Stats($playerid);
		$data  = $stats->get('rankings', $name_of_ranking);
		
		if ($data->rank) {
			$top = $stats->form($data->rank, Array('ratio', $data->count, 0, '%'), false);
			
			if      ($top["raw"] >= 0.90) { $pos = 12; }
			else if ($top["raw"] >= 0.70) { $pos = 24; }
			else if ($top["raw"] >= 0.30) { $pos = 36; }
			else if ($top["raw"] >= 0.10) { $pos = 48; }
			else                          { $pos = 60; }
			
			$sort = $top['sort'];
			$tip = $tpl->phrase('global_position').': '.$data->rank.'/'.$data->count.' ('.$top['format'].')';
			$string = '<a href="'.$data->url.'" target="_blank"><div class="ezDetail-Arrows" style="background-position: 0 -'.$pos.'px"></div></a>';
		} else {
			$sort = "0000000002000000";
			$tip = "";
			$string = '<div class="ezDetail-Arrows" style="background-position: 0 0px"></div>';
		}
		
		if ($cell_array) {
			return Array(
				'format' => $string,
				'tip' =>    $tip,
				'sort' =>   $sort
			);
		} else {
			return '<span title="'.$tip.'" style="display: inline-block">'.$string.'</span>';
		}
	}
	
	
	### CREATE CONTENT ###
	function create_html($action) {
		global $sql, $func, $tpl, $playerid, $path, $plugin;
		$stats = new Stats($playerid);
		$html = "";
		
		
		if ($action == "detail_overview") {
			// Rank
			if (true) {
				$rank = $stats->get('basic', 'rank');
				$next = $rank->next;
				
				$rankimage = $func->rank_image($rank->nr, $path, true);
				
				$lastrank  = count($next) ? false : true;  
				$width = 280;
				$height = '2em';
				
				// Check if player has reached last rank
				if (count($next)) {
					// Score per Second
					$time =   $stats->get('basic', 'timePlayed');
					$spsec = $stats->get('basic', 'score', Array('ratio', $time, 2));
					
					// Time until Rankup
					$score_left = $next->needed - $next->curr;
					$time = $score_left / $spsec;
					$time = $stats->form($time, Array('time', 0, 'date'), false);
					$time = $time['format'];
					
					// Tooltipp
					eval ("\$ttipp_rank = \"".$tpl->template("detail_overview_rank")."\";");
					
					// Variables
					$bar_width = floor($width * $next->relProg / 100);
					$perc = floor($next->relProg).'%';
					$phrase = '~ '.$time.' '.$tpl->phrase('rank_progress');
				} 
				
				// Player has reached last rank
				else {
					$bar_width = $width;
					$phrase = "";
					$perc = "";
					$ttipp_rank = '<p>'.$tpl->phrase('progress_desc_lastrank').'</p>';
				}
				
				$rankbar    = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.$bar_width.'px; height: '.$height.'"></div><span>'.$perc.'</span></div>';
			}
			
			
			// Skill
			if (true) {
				$size     = 8;
				$skill    = $stats->get('stats', 'skill');
				$pos      = ($skill/10) - ($size/2);
				$skillbar = '<div class="rankbar" style="width: 100px; margin: 5px auto; cursor: default;"><div class="rankline" style="width: '.$size.'px; height: '.$size.'px; margin-left: '.$pos.'px"></div></div>';
				
				$kdr = $stats->get('stats', 'kills', Array('ratio', $stats->get('stats', 'deaths'), 2));
				$spm = $stats->get('basic', 'score', Array('ratio', ($stats->get('stats', 'timePlayed') / 60), 0));
				$kpm = $stats->get('stats', 'kills', Array('ratio', ($stats->get('stats', 'timePlayed') / 60), 2));
				$wlr = $stats->get('stats', 'numWins', Array('ratio', $stats->get('stats', 'numLosses'), 2));
				$score = $stats->get('basic', 'score', Array('number', 0, "", "score"), false); $score = $score['format'];
				$time = $stats->get('stats', 'timePlayed', Array('time', 0, 'date'));
			}
			
			
			// Dogtags
			if (true) {
				$url = "http://battlelog-cdn.battlefield.com/cdnprefix/913d2fda1edf4a2ed5f2/public/profile/warsaw/gamedata/dogtags/large/";
				
				$a = $stats->get('dogtags', 'advanced');
				$b = $stats->get('dogtags', 'basic');
				
				$urla = $url.$a->image.'.png';
				$urlb = $url.$b->image.'.png';
				
				$tag  = $stats->get('basic', 'tag');
				$tag  = $tag ? '['.$tag.']' : "";
				$name = $stats->get('basic', 'name');
				
				eval ("\$ttipp_dgt = \"".$tpl->template("detail_overview_dogtags")."\";");
			}
			
			$state = date("d.m.Y - H:i", $stats->get('basic', 'dateUpdate'));
			eval ("\$html = \"".$tpl->template("detail_overview")."\";");
		}
		
		
		if ($action == "detail_stats") {
			// Kits
			if (true) {
				$kits = $stats->get('stats', 'kits');
				$kit_rows = Array();
				$kit_score = 0; // Overall kit score - needed at general stats
				$i = 0;
				
				$offset = Array(
					"assault" => 0,
					"engineer" => 32,
					"support" => 64,
					"recon" => 96,
					"commander" => 128
				);
				
				foreach ($kits as $name => $kit) {
					$kit_rows[$i]['icon'] = row(Array(
						'format' => '<div style="width: 32px; height: 32px; background-image: url('.$path.'styles/icons/kits/tiny.png); background-position: 0 -'.$offset[$name].'px"></div>',
						'sort' =>   $kit->score
					), "tcenter");
					
					$kit_rows[$i]['name'] = row(Array(
						'format' => $kit->name,
						'sort' =>   $kit->name
					), "tleft");
					
					$kit_rows[$i]['stars'] = row(Array(
						'format' => '<div class="ezSstar" style="'.($kit->stars ? '' : 'opacity: 0.5').'">'.$kit->stars.'</div>',
						'tip' =>    $tpl->phrase('star').': '.$kit->stars,
						'sort' =>   $kit->score
					), "tcenter");
					
					$kit_rows[$i]['ranking'] = row(ranking($name, true), "tcenter");
					
					$kit_rows[$i]['score'] = row($stats->form($kit->score, Array('number', 0, '', 'score'), false));
					
					$kit_rows[$i]['time'] = row($stats->form($kit->time, Array('time', 1, 'h'), false));
					
					$kit_rows[$i]['spm'] = row($stats->form($kit->score, Array('ratio', ($kit->time/60), 0, '', 'spm'), false));
					
					$kit_rows[$i] = implode($kit_rows[$i]);
					
					$kit_score += $kit->score;
					$i++;
				}
				
				$kit_rows = implode('</tr><tr>', $kit_rows);
			}
			
			// Modes
			if (true) {
				$modes = $stats->get('stats', 'modes');
				$modes_rows = Array();
				
				$offset = Array(
					"Conquest" => 0,
					"Rush" => 32,
					"Deathmatch" => 64,
					"Domination" => 96,
					"Obliteration" => 128,
					"Defuse" => 160
				);
				
				for ($i=0; $i < count($modes); $i++) {
					if (array_key_exists($modes[$i]->name, $offset)) { // Show only default game modes. DLC game modes have no stats.
						$modes_rows[$i]['icon'] = row(Array(
							'format' => '<div style="width: 32px; height: 32px; background-image: url('.$path.'styles/icons/modes/tiny.png); background-position: 0 -'.$offset[$modes[$i]->name].'px"></div>',
							'sort' =>   $modes[$i]->score
						), "tcenter");
						
						$modes_rows[$i]['name'] = row(Array(
							'format' => $modes[$i]->name,
							'sort' =>   $modes[$i]->name
						), "tleft");
						
						
						$modes_rows[$i]['ranking'] = row(ranking($modes[$i]->name, true), "tcenter");
						
						$modes_rows[$i]['score'] = row($stats->form($modes[$i]->score, Array('number', 0, '', 'score'), false));
						
						$modes_rows[$i] = implode($modes_rows[$i]);
					}
				}
				
				$modes_rows = implode('</tr><tr>', $modes_rows);
			}
			
			// General Stats
			if (true) {
				// Global ranking
				$r = Array();
				$rankings = $stats->get('rankings');
				foreach ($rankings as $key => $obj) {
					$key1 = str_replace('-', "", $key);
					$r[$key1] = ranking($key);
				}
				
				$s = $stats->get('stats');
				
				$s['kills']				= $stats->form($s['kills'], Array('number', 0));
				$s['deaths']			= $stats->form($s['deaths'], Array('number', 0));
				$s['kdr']				= $stats->form($s['extra']->kdr, Array('number', 2));
				$kdr_color				= ($s['kdr'] >= 1) ? "positive" : "negative";
				$s['skill']				= $stats->form($s['skill'], Array('number', 0));
				$s['spm']				= $stats->form($s['extra']->spm, Array('number', 0));
				$s['kpm']				= $stats->form($s['extra']->kpm, Array('number', 2));
				$s['killAssists']		= $stats->form($s['killAssists'], Array('number', 0));
				$s['dogtagsTaken']		= $stats->form($s['dogtagsTaken'], Array('number', 0));
				$s['numWins']			= $stats->form($s['numWins'], Array('number', 0));
				$s['numLosses']			= $stats->form($s['numLosses'], Array('number', 0));
				$s['wlr']				= $stats->form($s['extra']->wlr, Array('number', 2));
				$wlr_color				= ($s['wlr'] >= 1) ? "positive" : "negative";
				$s['shotsFired']		= $stats->form($s['shotsFired'], Array('number', 0));
				$s['shotsHit']			= $stats->form($s['shotsHit'], Array('number', 0));
				$s['accuracy']			= $stats->form($s['extra']->accuracy, Array('number', 2));
				
				$s['vehicle']			= $stats->form($s['scores']->vehicle, Array('number', 0));
				$s['award']				= $stats->form($s['scores']->award, Array('number', 0));
				$s['unlock']			= $stats->form($s['scores']->unlock, Array('number', 0));
				$s['totalScore']		= $stats->form($s['scores']->totalScore, Array('number', 0));
				$s['bonus']				= $stats->form($s['scores']->bonus, Array('number', 0));
				$s['objective']			= $stats->form($s['scores']->objective, Array('number', 0));
				$s['squad']				= $stats->form($s['scores']->squad, Array('number', 0));
				$s['team']				= $stats->form($s['scores']->team, Array('number', 0));
				
				$s['repairs']			= $stats->form($s['repairs'], Array('number', 0));
				$s['revives']			= $stats->form($s['revives'], Array('number', 0));
				$s['heals']				= $stats->form($s['heals'], Array('number', 0));
				$s['resupplies']		= $stats->form($s['resupplies'], Array('number', 0));
				$s['avengerKills']		= $stats->form($s['avengerKills'], Array('number', 0));
				$s['saviorKills']		= $stats->form($s['saviorKills'], Array('number', 0));
				$s['suppressionAssists']= $stats->form($s['suppressionAssists'], Array('number', 0));
				$s['flagCaptures']		= $stats->form($s['flagCaptures'], Array('number', 0));
				$s['flagDefend']		= $stats->form($s['flagDefend'], Array('number', 0));
				$quits 					= $stats->form( 1 - (($stats->get('stats', 'numLosses') + $stats->get('stats', 'numWins')) / $stats->get('stats', 'numRounds')), Array('number', 0, "%"));
				
				
				
				$s['vehiclesDestroyed']	= $stats->form($s['vehiclesDestroyed'], Array('number', 0));
				$s['vehicleDamage']		= $stats->form($s['vehicleDamage'], Array('number', 0));
				$hskillperc				= $stats->form($s['headshots'], Array('ratio', $stats->get('stats', 'kills'), 1, '%'));
				$s['headshots']			= $stats->form($s['headshots'], Array('number', 0));
				$s['longestHeadshot']	= $stats->form($s['longestHeadshot'], Array('number', 0));
				$s['killStreakBonus']	= $stats->form($s['killStreakBonus'], Array('number', 0));
				$s['nemesisKills']		= $stats->form($s['nemesisKills'], Array('number', 0));
				$s['nemesisStreak']		= $stats->form($s['nemesisStreak'], Array('number', 0));
			}
			
			eval ("\$html = \"".$tpl->template("detail_stats")."\";");
		}
		
		
		if ($action == "detail_vehicles") {
			eval ("\$html = \"".$tpl->template("detail_vehicles")."\";");
			$html = new PQLite($html);
			
			
			// Vehicle Categories
			if (true) {
				$vehcats = $stats->get('vehicleCategory');
				$vehcats_sort = Array(); // Array with IDs of vehicle categories, sorted by playtime
				$vehcats_list = ""; // List for vehcat filter function
				$vehcats_offset = array_flip(Array('Infantry Fighting Vehicle', 'Anti Air', 'Air Jet Stealth', 'Air Jet Attack', 'Weapon Stationary', 'Main Battle Tanks', 'Transport', 'Air Helicopter Attack', 'Air Helicopter Scout', 'Fast Attack Craft', 'Soldier Equiment', 'Boat', 'Mobile Artillery', 'Air', 'Weapon Stationary AA'));
				$img = $path.'styles/icons/vehcats/medium.png';
				
				
				foreach ($vehcats as $key => $obj) {
					$vehcats_sort[$obj->stat->time] = $key;
				}
				ksort($vehcats_sort);
				$vehcats_sort = array_reverse($vehcats_sort, true);
				
				
				foreach ($vehcats_sort as $id) {
					$headline = $vehcats[$id]->name;
					$vehcats_list = '<li style="display: none"> - <a href="#">'.$headline.'</a></li>';
					$image = '<div class="ezVehcatImg" style="background-image: url('.$img.'); background-position: 0 -'.(64 * $vehcats_offset[trim($headline)]).'px"></div>';
					
					$kills = $stats->form($vehcats[$id]->stat->kills, Array('number', 0));
					$destroys = $stats->form($vehcats[$id]->stat->destroys, Array('number', 0));
					$time = $stats->form($vehcats[$id]->stat->time, Array('time', 0, 'dynamic'));
					$kpm = $stats->form($vehcats[$id]->stat->kills, Array('ratio', ($vehcats[$id]->stat->time / 60), 2));
					
					eval ("\$detail_vehicles_vehcats = \"".$tpl->template("detail_vehicles_vehcats")."\";");
					$html->find('#ezVehcats')->appendHTML($detail_vehicles_vehcats);
					$html->find('.ezFilter')->appendHTML($vehcats_list);
				}
			}
			
			
			// Vehicles
			if (true) {
				$vehicles = $stats->get('vehicles');
				$vehcats_offset = array_flip(Array('Vehicle Infantry Fighting Vehicle', 'Vehicle Anti Air', 'Vehicle Air Jet Stealth', 'Vehicle Air Jet Attack', 'Weapon Stationary', 'Vehicle Main Battle Tanks', 'Vehicle Transport', 'Vehicle Air Helicopter Attack', 'Vehicle Air Helicopter Scout', 'Vehicle Fast Attack Craft', 'Soldier Equiment', 'Vehicle Boat', 'Vehicle Mobile Artillery', 'Vehicle Air', 'Weapon Stationary AA'));
				
				
				foreach ($vehicles as $vehicle) {
					$td = Array();
					$vehicle->category = str_replace("Vehicle ", "", $vehicle->detail->category); // Removes "Vehicle " from Vehcat-Name
					$img = $path.'styles/icons/vehcats/tiny.png';
					
					$td['name'] = row(Array(
						'format' => $vehicle->name,
						'tip' =>    '<div class="ezInfo" style="width: 180px;"><img src="'.$path.'styles/icons/vehicles/'.$vehicle->detail->image.'.png" width="180" height="45" /></div>',
						'sort' =>   $vehicle->name,
					), "tleft", $vehicle->stat->id);
					
					$td['ranking'] = row(ranking($vehicle->detail->id, true), "tcenter");
					
					$td['vehcat'] = row(Array(
						'format' => '<div style="width: 32px; height: 32px; background-image: url('.$img.'); background-position: 0 -'.($vehcats_offset[trim($vehicle->detail->category)] * 32).'px"></div>',
						'tip' =>    $vehicle->category,
						'sort' =>   $vehicle->category,
					), "tcenter");
					
					$td['kills'] = row($stats->form($vehicle->stat->kills, Array('number', 0, '', "kills"), false));
					
					$td['time'] = row($stats->form($vehicle->stat->time, Array('time', 0, 'dynamic'), false));
					
					$td['kpm'] = row($stats->form($vehicle->stat->kills, Array('ratio', ($vehicle->stat->time / 60), 2, '', 'kpm'), false));
					
					$td['destroys'] = row($stats->form($vehicle->stat->destroys, Array('number', 0, '', "destroys"), false));
					
					$td['dpm'] = row($stats->form($vehicle->stat->destroys, Array('ratio', ($vehicle->stat->time / 60), 2, '', 'dpm'), false));
					
					$html->find('#ezVehicles tbody')->appendHTML('<tr name="'.$vehicle->category.'">'.implode('', $td).'</tr>');
				}
			}
			
			
			$html = $html->getHTML();
		}
		
		
		if ($action == "detail_weapons") {
			eval ("\$html = \"".$tpl->template("detail_weapons")."\";");
			$html = new PQLite($html);
			
			$weapons = $stats->get('weapons');
			$top = Array("favourite" => Array(), "deadliest" => Array(), "accurate" => Array(), "dangerous" => Array()); // Array for Top Weapons
			$allowed = Array('SNIPER RIFLE', 'CARBINE', 'LMG', 'DMR', 'ASSAULT RIFLE', 'PDW', 'SHOTGUN');
			$img = $path.'styles/icons/weapcats/tiny.png';
			$weapcats_sort = Array ('SNIPER RIFLE' => 0, 'CARBINE' => 0, 'GADGET' => 0, 'BATTLE PICKUP' => 0, 'LMG' => 0, 'GRENADE' => 0, 'DMR' => 0, 'ASSAULT RIFLE' => 0, 'PDW' => 0, 'KNIFE' => 0, 'SHOTGUN' => 0, 'SIDEARM' => 0);
			$weapcats_offset = array_flip(Array('SNIPER RIFLE', 'CARBINE', 'GADGET', 'BATTLE PICKUP', 'LMG', 'GRENADE', 'DMR', 'ASSAULT RIFLE', 'PDW', 'KNIFE', 'SHOTGUN', 'SIDEARM'));
			
			
			// Weapons Table
			if (true) {
				foreach ($weapons as $key => $weapon) {
					$td = Array();
					$weapcats_sort[$weapon->detail->category] += $weapon->stat->kills; // for Weapcats filter list
					
					// Weapon Information Tooltipp
					if (true) {
						$img_src = $path.'styles/icons/weapons/'.$weapon->detail->image.'.png';
						
						if (isset($weapon->detail->weaponData)) {
							$data    = $weapon->detail->weaponData;
							$width   = 300;
							
							$statDamage    = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $data->statDamage).'px;"></div><span>'.$tpl->phrase('statDamage').': '.floor($data->statDamage * 100).'</span></div>';
							$statAccuracy  = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $data->statAccuracy).'px;"></div><span>'.$tpl->phrase('statAccuracy').': '.floor($data->statAccuracy * 100).'</span></div>';
							$statMobility  = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $data->statMobility).'px;"></div><span>'.$tpl->phrase('statMobility').': '.floor($data->statMobility * 100).'</span></div>';
							$statRange     = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $data->statRange).'px;"></div><span>'.$tpl->phrase('statRange').': '.floor($data->statRange * 100).'</span></div>';
							if ($data->rateOfFire) {
								$rateOfFire    = '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $data->rateOfFire / 1000).'px;"></div><span>'.$tpl->phrase('rateOfFire').': '.floor($data->rateOfFire).'</span></div>';
							} else $rateOfFire = "";
							
						} else {
							$statDamage = $statAccuracy = $statMobility = $statRange = $rateOfFire = "";
						}
						
						eval ("\$wp_info = \"".$tpl->template("detail_weapons_info")."\";");
					}
					
					
					// Fix Accuracy for Shotguns
					if ($weapon->detail->category == "SHOTGUN") {
						$pellets = Array(
							'dbv-12' => 9,
							'hawk-12g' => 14,
							'm1014' => 9,
							'qbs-09' => 11,
							'870-mcs' => 12,
							'saiga-12k' => 9,
							'spas-12' => 11,
							'uts-15' => 10,
							'dao-12' => 9
						);
						$weapon->stat->hits = $weapon->stat->hits / $pellets[$weapon->detail->id];
					}
					
					
					// Load Stats for Top-Weapons-Overview
					if (true) {
						if ($weapon->stat->kills >= 25 AND in_array($weapon->detail->category, $allowed)) {
							$top['favourite'][$key] = $weapon->stat->kills;
							$top['deadliest'][$key] = (int)round($weapon->stat->kills / $weapon->stat->time * 1000);
							$top['accurate'][$key]  = (int)round($weapon->stat->hits / $weapon->stat->shots * 1000);
							$top['dangerous'][$key] = (int)round($weapon->stat->hs / $weapon->stat->kills * 1000);
						}
					}
					
					
					$td['name'] = row(Array(
						'format' => $weapon->name,
						'tip' =>    $wp_info,
						'sort' =>   $weapon->name,
					), "tleft", $weapon->stat->id);
					
					$td['stars'] = row(Array(
						'format' => '<div class="ezSstar" style="'.($weapon->stars->count ? '' : 'opacity: 0.5').'">'.$weapon->stars->count.'</div>',
						'tip' =>    $tpl->phrase('star').': '.$weapon->stars->count.' - '.$tpl->phrase('star_kills_left').': '.($weapon->stars->needed - $weapon->stars->curr),
						'sort' =>   $weapon->stat->kills,
					), "tcenter");
					
					
					$td['ranking'] = row(ranking($weapon->detail->id, true), "tcenter");
					
					
					$td['weapcat'] = row(Array(
						'format' => '<div style="width: 32px; height: 32px; background-image: url('.$img.'); background-position: 0 -'.($weapcats_offset[$weapon->detail->category] * 32).'px"></div>',
						'tip' =>    $weapon->detail->category.' - '.$weapon->detail->type,
						'sort' =>   $weapon->detail->category,
					), "tcenter");
					
					
					$td['time'] = row($stats->form($weapon->stat->time, Array('time', 0, 'dynamic'), false));
					
					$td['kills'] = row($stats->form($weapon->stat->kills, Array('number', 0, '', "kills"), false));
					
					
					$result = $stats->form($weapon->stat->hs, Array('number'));
					$td['hs'] = row(Array(
						'format' => $result,
						'tip' =>    $tpl->phrase('headshots').': '.$result,
						'sort' =>   $weapon->stat->hs,
					));
					
					
					$result = $stats->form($weapon->stat->hs, Array('ratio', $weapon->stat->kills, 0, '%'), false);
					$td['hsp'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('headshots').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->kills, Array('ratio', ($weapon->stat->time / 60), 2), false);
					$td['kpm'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('kills_per_minute').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->shots, Array('ratio', ($weapon->stat->time / 60)), false);
					$td['shotspm'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('label_shots_per_minute').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$result = $stats->form($weapon->stat->hits, Array('ratio', $weapon->stat->shots, 0, '%'), false);
					$td['acc'] = row(Array(
						'format' => $result['format'],
						'tip' =>    $tpl->phrase('accuracy').': '.$result['format'],
						'sort' =>   $result['sort'],
					));
					
					
					$html->find('#ezWeapons tbody')->appendHTML('<tr name="'.$weapon->detail->category.'">'.implode('', $td).'</tr>');
				}
			}
			
			
			/* Top-Weapons-Overview */
			foreach ($top as $key => $array) {
				asort($array, SORT_NUMERIC); $array = array_flip($array);
				
				if (count($array)) {
					$weapon = $weapons[array_pop($array)];
					
					$headline = $tpl->phrase($key.'_weapon');
					$src = $path.'styles/icons/weapons/'.$weapon->detail->image.'.png';
					
					switch($key) {
						case "favourite":
							$property = $tpl->phrase("kills");
							$result =   $stats->form($weapon->stat->kills, Array('number', 0), false);
							break;
						case "deadliest":
							$property = $tpl->phrase("kills_per_minute");
							$result =   $stats->form($weapon->stat->kills, Array("ratio", ($weapon->stat->time / 60), 2), false);
							break;
						case "accurate":
							$property = $tpl->phrase("accuracy");
							$result =   $stats->form($weapon->stat->hits, Array("ratio", $weapon->stat->shots, 0, "%"), false);
							break;
						case "dangerous":
							$property = $tpl->phrase("headshots");
							$result =   $stats->form($weapon->stat->hs, Array("ratio", $weapon->stat->kills, 0, "%"), false);
							break;
					}
					
					eval ("\$cell = \"".$tpl->template("detail_weapons_top")."\";");
					$html->find('#ezTopWeapons')->appendHTML($cell);
				}
			}
			
			
			// Weapons Category filter list
			if (true) {
				$weapcats_sort = array_flip($weapcats_sort);
				ksort($weapcats_sort);
				$weapcats_sort = array_reverse($weapcats_sort, true);
				
				foreach ($weapcats_sort as $value) {
					$html->find('.ezFilter')->appendHTML('<li style="display: none"> - <a href="#">'.$value.'</a></li>');
				}
				
			}
			
			
			$html = $html->getHTML();
		}
		
		
		if ($action == "detail_gadgets") {
			$gadgets = $stats->get('kititems');
			
			$offset = Array(
				"assault" => 0,
				"engineer" => 32,
				"support" => 64,
				"recon" => 96,
				"commander" => 128
			);
			
			function unlock($gadget) {
				if (isset($gadget->detail->unlock) AND is_object($gadget->detail->unlock)) {
					if ($gadget->detail->unlock->needed > $gadget->curr) {
						return "opacity: 0.3";
					} else {
						return "";
					}
				} else {
					return "";
				}
			}
			
			foreach ($gadgets as $gadget) {
				if (isset($gadget->stat) AND is_object($gadget->stat)) {
					$kills = isset($gadget->stat->kills) ? $gadget->stat->kills : "";
					$repairs = isset($gadget->stat->repairs) ? $gadget->stat->repairs : "";
					$revives = isset($gadget->stat->revives) ? $gadget->stat->revives : "";
					$heals = isset($gadget->stat->heals) ? $gadget->stat->heals : "";
					$shots = isset($gadget->stat->shots) ? $gadget->stat->shots : "";
					$spawns = isset($gadget->stat->spawns) ? $gadget->stat->spawns : "";
					$spotAssists = isset($gadget->stat->spotAssists) ? $gadget->stat->spotAssists : "";
					$damageAssists = isset($gadget->stat->damageAssists) ? $gadget->stat->damageAssists : "";
					$resupplies = isset($gadget->stat->resupplies) ? $gadget->stat->resupplies : "";
					
					
					$id = str_replace(Array('-'), '', $gadget->detail->id);
					$$id = Array(
						'kills'     => $kills,
						'repairs'   => $repairs,
						'revives'   => $revives,
						'heals'     => $heals,
						'shots'     => $shots,
						'spawns'    => $spawns,
						'spotAssists' => $spotAssists,
						'damageAssists' => $damageAssists,
						'resupplies' => $resupplies,
						'name'      => $gadget->name,
						'desc'      => $gadget->detail->desc,
						'image'     => $path.'styles/icons/gadgets/'.$gadget->detail->image.'.png',
						'kit'       => '<div style="width: 32px; height: 32px; background-image: url('.$path.'styles/icons/kits/tiny.png); background-position: 0 -'.$offset[$gadget->detail->kit].'px"></div>',
						'unlock'    => unlock($gadget)
					);
				}
			}
			
			//echo "<pre>";
			//print_r($repairtool);
			
			eval ("\$html = \"".$tpl->template("detail_gadgets")."\";");
		}
		
		
		if ($action == "detail_assignments") {
			$categories = Array('bronze', 'silver', 'gold', 'premium', 'phantom', 'sp');
			
			// Order Assignments by Assignment-ID
			if (true) {
				$list = Array();
				foreach ($stats->get('assignments') as $key => $value) {
					$str = strtolower($value->id);
					$list[$str] = $key;
				}
				ksort($list, SORT_STRING);
				
				$ass = $stats->get('assignments');
				$assignments = Array();
				foreach ($list as $key => $value) {
					$assignments[] = $ass[$value];
				}
			}
			
			
			$style = $func->load_settings('style');
			eval ("\$html = \"".$tpl->template("detail_assignments")."\";");
			$html = new PQLite($html);
			
			foreach ($categories as $category) {
				foreach ($assignments as $assignment) {
					if ($assignment->category == $category) {
						$width      = 128;
						$widthpx    = $width.'px';
						$completed  = ($assignment->curr == $assignment->needed) ? "completed" : "";
						$opacity    = ($completed == "completed") ? "" : "opacity: 0.3";
						
						$name       = str_replace(" (Campaign)", "", $assignment->name);
						$dlc_img    = strtolower(substr($assignment->id, 0, 2)) == "xp" ? $path.'styles/images/dlc_'.strtolower(substr($assignment->id, 0, 3)).'.png' : "";
						$desc       = $assignment->desc;
						$img        = $path.'styles/icons/missions/'.$assignment->image.'.png';
						
						$depend     = ($assignment->curr == 0 AND isset($assignment->dependencies[0])) ? '&nbsp;'.$assignment->dependencies[0]->name.'&nbsp;' : "";
						$depend     = str_replace("PLAY AS PREMIUM ONCE", "Premium", $depend);
						
						$progress   = ($assignment->prog != 0 AND $assignment->prog != 100) ? '<div class="rankbar" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $assignment->prog / 100).'px;"></div></div>' : '';
						
						
						
						$list = "";
						foreach ($assignment->criterias as $c) {
							$list .= '<li>'.$c->desc.': '.$c->curr.'/'.$c->needed.'</li>';
						}
						
						eval ("\$result = \"".$tpl->template("detail_assignments_assignment")."\";");
						$html->find('#'.$category)->appendHTML($result);
					}
				}
			}
			
			
			$html = $html->getHTML();
		}
		
		
		if ($action == "detail_awards") {
			$awards = $stats->get('awards');
			$categories = Array('gamemode', 'weapon', 'vehicles', 'kits', 'team', 'general');
			
			$mAll   = 0;
			$mCount = 0; $rCount = 0; 
			$mSum   = 0; $rSum   = 0;
			
			$style = $func->load_settings('style');
			eval ("\$html = \"".$tpl->template("detail_awards")."\";");
			$html = new PQLite($html);
			
			foreach ($categories as $category) {
				foreach ($awards as $award) {
					if ($award->medal->category == $category) {
						$mAll       = $mAll + 1;
						$mCount     = $award->mCount ? ($mCount = $mCount +1) : $mCount;
						$rCount     = $award->rCount ? ($rCount = $rCount +1) : $rCount;
						$mSum       = $mSum + $award->mCount;
						$rSum       = $rSum + $award->rCount;
						
						if ($award->id == "m09") {
							$mvpSum = $award->rCount;
							$mvpRank = ranking('r09');
						}
						if ($award->id == "m08") {
							$aceSum = $award->rCount;
							$aceRank = ranking('r08');
						}
						
						$width      = 128;
						$widthpx    = $width.'px';
						$height     = 40;
						$opacity    = $award->mCount ? "" : "opacity: 0.3";
						
						$name       = str_replace(" MEDAL", "", $award->mName);
						$count      = $award->mCount.'x';
						$mImg       = $path.'styles/icons/medals/'.$award->medal->image.'.png';
						$rImg       = $path.'styles/icons/ribbons/'.$award->ribbon->image.'.png';
						$mTitle     = $tpl->phrase('progress').': '.$award->curr.'/'.$award->needed.' '.$award->rName;
						$rTitle     = $award->ribbon->desc;
						$progress   = '<div class="rankbar" title="'.$mTitle.'" style="width: '.$width.'px"><div class="rankline" style="width: '.floor($width * $award->curr / $award->needed).'px;"></div></div>';
						
						
						eval ("\$result = \"".$tpl->template("detail_awards_award")."\";");
						$html->find('#'.$category)->appendHTML($result);
					}
				}
			}
			
			$unique_medals     = $mCount.'/'.$mAll.' ('.$stats->form($mCount, Array('ratio', $mAll, 0, '%')).')';
			$medals_count      = $stats->form($mSum, Array('number'));
			$medals_per_hour   = $stats->form($mSum, Array('ratio', ($stats->get('stats', 'timePlayed')/3600), 2));
			
			$unique_ribbons     = $rCount.'/'.$mAll.' ('.$stats->form($rCount, Array('ratio', $mAll, 0, '%')).')';
			$ribbons_count      = $stats->form($rSum, Array('number'));
			$ribbons_per_minute = $stats->form($rSum, Array('ratio', ($stats->get('stats', 'timePlayed')/60), 2));
			$ribbons_per_round  = $stats->form($rSum, Array('ratio', ($stats->get('stats', 'numRounds')), 2));
			$ribpr              = ranking('ribpr');
			
			$mvp_count      = $stats->form($mvpSum, Array('number'));
			$mvp_per_round  = $stats->form($mvpSum, Array('ratio', ($stats->get('stats', 'numRounds')), 2));
			
			$ace_count      = $stats->form($aceSum, Array('number'));
			$ace_per_round  = $stats->form($aceSum, Array('ratio', ($stats->get('stats', 'numRounds')), 2));
			
			eval ("\$result = \"".$tpl->template("detail_awards_overview")."\";");
			$html->find('#overview')->appendHTML($result);
			
			$html = $html->getHTML();
		}
		
		
		if ($action == "detail_history") {
			if (isset($_GET['mode'])) {
				// Only refresh the image
				$mode = $_GET['mode'];
				
				require 'scripts/vendor/pChart.data.php';
				require 'scripts/vendor/pChart.draw.php';
				require 'scripts/vendor/pChart.image.php';
				require 'history.php';
				
				$html  = $path.'tmp/history'.$playerid.'.png?'.rand(); // Random number is required to avoid browser caching
			} 
			
			else {
				// Refresh image and create template
				$mode = "score";
				
				require 'scripts/vendor/pChart.data.php';
				require 'scripts/vendor/pChart.draw.php';
				require 'scripts/vendor/pChart.image.php';
				require 'history.php';
				
				$src = $path.'tmp/history'.$playerid.'.png?'.rand(); // Random number is required to avoid browser caching
				eval ("\$html = \"".$tpl->template("detail_history")."\";");
				
				$html = new PQLite($html);
				$html = $html->getHTML();
			}
		}
		
		
		if ($action == "detail_signatures") {
			$sig = new Signatures($playerid);
			$sig->create_signature('');
			$vars = $func->load_settings("signatures");
			
			eval ("\$html = \"".$tpl->template("detail_signatures")."\";");
			$html = new PQLite($html);
			
			// Create Array with types of signatures
			$data = $func->load_settings("signatures");
			$types = Array();
			foreach ($data as $name => $value) $types[] = substr($name, 0, strpos($name, "_"));
			$types = $func->array_unique($types);
			
			// Add signatures to template
			foreach ($types as $type) {
				$url  = (empty($_SERVER['HTTPS']) ? "http://" : "https://").$_SERVER['HTTP_HOST'].str_replace("detail.php", "signatures/".$playerid."_".$type.".png", $_SERVER['PHP_SELF']);
				$bb   = "[IMG]".$url."[/IMG]";
				$htm  = htmlentities('<img src="'.$url.'" />');
				
				eval ("\$signature = \"".$tpl->template("detail_signatures_signature")."\";");
				$html->find('ul')->appendHTML($signature);
			}
			
			$html = $html->getHTML();
		}
		
		
		return $html;
	}
	
	
	### LOAD PAGES ###
	if ($action == "default") {
		if ($playerid) {
			$stats = new Stats($playerid);
			$basic  = $stats->get('basic');
		} else die("ERROR: No playerid given");
		
		$tag  = $basic['tag'] ? '['.$basic['tag'].']' : "";
		$name = $tag.$basic['name'];
		$showhis = $stats->get("player", "history_enough_data") ? "display: block" : "display: none";
		$showsig = $settings->get("functions_signatures") ? "display: block" : "display: none";
		
		eval ("\$html = \"".$tpl->template("detail")."\";");
		
		$html = new PQLite($html);
		$html->find('#ezContent')->appendHTML(create_html('detail_overview'));
		
		die ($html->getHTML());
	} else {
		die(create_html($action));
	}
?>