<?php
	### CREATE CHART ###
	
	/* Start the Chart */
	$myData = new pData();
	$myData->loadPalette("scripts/vendor/pChart.color", TRUE);
	
	/* X-Axis */
	if (true) {
		// Get the first and last entry in the History
		$sql->query('SELECT date FROM '.$sql->prefix.'stats__history WHERE playerid = "'.$playerid.'" ORDER BY date ASC LIMIT 1');  $start = $sql->fetchRow("date");
		$sql->query('SELECT date FROM '.$sql->prefix.'stats__history WHERE playerid = "'.$playerid.'" ORDER BY date DESC LIMIT 1'); $end   = $sql->fetchRow("date");
		
		// Create Array with fourteen dates for the data points
		$dates = Array();
		$interval = ($end - $start)/ 13;
		for ($i = 0; $i <= 13; $i++) $dates[] = $start + ($i * $interval);
		
		$myData->addPoints($dates,"Absissa");
		$myData->setAbscissa("Absissa");
		$myData->setXAxisDisplay(AXIS_FORMAT_DATE, "d.m.y");
	}
	
	
	/* Load History data and save it into stats array */
	if (true) {
		$values = Array('score', 'rank', 'timePlayed', 'kills', 'deaths', 'skill', 'numRounds', 'shotsFired', 'spm', 'kpm', 'kdr', 'accuracy', 'hkp', 'wlr', 'quits', 'assault', 'engineer', 'support', 'recon', 'commander');
		$stats = Array();
		foreach ($values as $val) {
			$stats[$val] = Array();
		}
		
		foreach ($dates as $date) {
			$sql->query('
				SELECT `stats`
				FROM '.$sql->prefix.'stats__history 
				WHERE playerid = "'.$playerid.'" 
				AND date >= '.$date.' 
				ORDER BY id
				LIMIT 1
			'); 
			$result = $sql->fetchAssoc();
			$result = json_decode($result['stats']);
			
			$stats['score'][$date] = $result->scores->score;
			$stats['rank'][$date] = $result->rank;
			$stats['timePlayed'][$date] = $result->timePlayed /3600;
			
			$stats['kills'][$date] = $result->kills;
			$stats['deaths'][$date] = $result->deaths;
			$stats['kdr'][$date] = $result->extra->kdr;
			
			$stats['shotsFired'][$date] = $result->shotsFired;
			$stats['accuracy'][$date] = $result->extra->accuracy;
			$stats['hkp'][$date] = $result->extra->hkp;
			
			$stats['skill'][$date] = $result->skill;
			$stats['spm'][$date] = $result->extra->spm;
			$stats['kpm'][$date] = $result->extra->kpm;
			
			$stats['numRounds'][$date] = $result->numRounds;
			$stats['wlr'][$date] = $result->extra->wlr;
			$stats['quits'][$date] = (1 - ($result->extra->roundsFinished / $result->numRounds)) *100;
			
			$stats['assault'][$date] = $result->kits->assault->score;
			$stats['engineer'][$date] = $result->kits->engineer->score;
			$stats['support'][$date] = $result->kits->support->score;
			$stats['recon'][$date] = $result->kits->recon->score;
			$stats['commander'][$date] = $result->kits->commander->score;
		}
	}
	
	
	/* Y-Axis */
	if (true) {
		if ($mode == "xxxscore") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['score'], "overall_score");
			$myData->setSerieDescription("overall_score", $tpl->phrase("overall_score"));
			$myData->setSerieOnAxis("overall_score", 0);
			
			$myData->addPoints($stats['spm'], "spm");
			$myData->setSerieDescription("spm", $tpl->phrase("spm"));
			$myData->setSerieOnAxis("spm", 1);
			
			$myData->addPoints($stats['kpm'], "kpm");
			$myData->setSerieDescription("kpm", $tpl->phrase("kills_per_minute"));
			$myData->setSerieOnAxis("kpm", 2);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisName(0, $tpl->phrase("score"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisName(1, "");
			$myData->setAxisUnit(1, "");
			
			$myData->setAxisPosition(2, AXIS_POSITION_RIGHT);
			$myData->setAxisName(2, $tpl->phrase("spm").' / '.$tpl->phrase("kills_per_minute"));
			$myData->setAxisUnit(2, "");
			
			/* Skalierung */
			$spm = $stats['spm']; sort($spm);
			$kpm = $stats['kpm']; sort($kpm);
			
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0,
				"ScaleSpacing" => 0,
				"Mode" => SCALE_MODE_MANUAL,
				"ManualScale" => Array(
					0 => Array("Min" => array_shift($stats['score']), "Max" => array_pop($stats['score'])),
					1 => Array("Min" => array_shift($spm), "Max" => array_pop($spm)),
					2 => Array("Min" => array_shift($kpm), "Max" => array_pop($kpm))
				)
			);
		}
		
		if ($mode == "score") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['rank'], "rank");
			$myData->setSerieDescription("rank", $tpl->phrase("rank"));
			$myData->setSerieOnAxis("rank", 0);
			
			$myData->addPoints($stats['score'], "score");
			$myData->setSerieDescription("score", $tpl->phrase("score"));
			$myData->setSerieOnAxis("score", 1);
			
			$myData->addPoints($stats['timePlayed'], "timePlayed");
			$myData->setSerieDescription("timePlayed", $tpl->phrase("time_played"));
			$myData->setSerieOnAxis("timePlayed", 2);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisName(0, $tpl->phrase("rank"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisDisplay(1, AXIS_FORMAT_METRIC);
			$myData->setAxisName(1, $tpl->phrase("score"));
			$myData->setAxisUnit(1, "");
			
			$myData->setAxisPosition(2, AXIS_POSITION_RIGHT);
			$myData->setAxisDisplay(2, AXIS_FORMAT_METRIC);
			$myData->setAxisName(2, $tpl->phrase("time_played").' (h)');
			$myData->setAxisUnit(2, "");
			
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0,
				"ScaleSpacing" => 10,
				"Mode" => SCALE_MODE_MANUAL,
				"ManualScale" => Array(
					0 => Array("Min" => 0, "Max" => 140),
					1 => Array("Min" => 0, "Max" => array_pop($stats['score'])),
					2 => Array("Min" => 0, "Max" => array_pop($stats['timePlayed']))
				)
			);
		}
		
		if ($mode == "kills") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['kills'], "kills");
			$myData->setSerieDescription("kills", $tpl->phrase("kills"));
			$myData->setSerieOnAxis("kills", 0);
			
			$myData->addPoints($stats['deaths'], "deaths");
			$myData->setSerieDescription("deaths", $tpl->phrase("deaths"));
			$myData->setSerieOnAxis("deaths", 0);
			
			$myData->addPoints($stats['kdr'], "kdr");
			$myData->setSerieDescription("kdr", $tpl->phrase("kdr"));
			$myData->setSerieOnAxis("kdr", 1);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisDisplay(0, AXIS_FORMAT_METRIC);
			$myData->setAxisName(0, $tpl->phrase("kills").' / '.$tpl->phrase("deaths"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisDisplay(1, AXIS_FORMAT_CUSTOM, "YAxisFormat");
			$myData->setAxisName(1, $tpl->phrase("kdr"));
			$myData->setAxisUnit(1, "");
			function YAxisFormat($val) { return(round($val, 2)); } 
			
			/* Skalierung */
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0
			);
		}
		
		if ($mode == "accuracy") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['shotsFired'], "shots");
			$myData->setSerieDescription("shots", $tpl->phrase("shots"));
			$myData->setSerieOnAxis("shots", 0);
			
			$myData->addPoints($stats['accuracy'], "acc");
			$myData->setSerieDescription("acc", $tpl->phrase("accuracy"));
			$myData->setSerieOnAxis("acc", 1);
			
			$myData->addPoints($stats['hkp'], "hsr");
			$myData->setSerieDescription("hsr", $tpl->phrase("hskillperc"));
			$myData->setSerieOnAxis("hsr", 1);
			
			/* Y-Achse Skala */
			$myData->setAxisDisplay(0, AXIS_FORMAT_METRIC);
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisName(0, $tpl->phrase("shots"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisDisplay(1, AXIS_FORMAT_CUSTOM, "YAxisFormat");
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisName(1, $tpl->phrase("accuracy").' / '.$tpl->phrase("hskillperc"));
			
			function YAxisFormat($val) { return(round($val, 1)."%"); } 
			
			/* Skalierung */
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0
			);
		}
		
		if ($mode == "matches") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['numRounds'], "rounds");
			$myData->setSerieDescription("rounds", $tpl->phrase("roundsplayed"));
			$myData->setSerieOnAxis("rounds", 0);
			
			$myData->addPoints($stats['wlr'], "wlr");
			$myData->setSerieDescription("wlr", $tpl->phrase("wlr"));
			$myData->setSerieOnAxis("wlr", 1);
			
			$myData->addPoints($stats['quits'], "quits");
			$myData->setSerieDescription("quits", $tpl->phrase("quits"));
			$myData->setSerieOnAxis("quits", 2);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisDisplay(0, AXIS_FORMAT_METRIC);
			$myData->setAxisName(0, $tpl->phrase("roundsplayed"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisDisplay(1, AXIS_FORMAT_CUSTOM, "YAxisFormat");
			$myData->setAxisName(1, $tpl->phrase("wlr"));
			$myData->setAxisUnit(1, "");
			
			$myData->setAxisPosition(2, AXIS_POSITION_RIGHT);
			$myData->setAxisName(2, $tpl->phrase("quits"));
			$myData->setAxisUnit(2, "%");
			
			function YAxisFormat($val) { return(round($val, 2)); } 
			
			/* Skalierung */
			$wlr = $stats['wlr']; sort($wlr);
			
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0,
				"ScaleSpacing" => 10,
				"Mode" => SCALE_MODE_MANUAL,
				"ManualScale" => Array(
					0 => Array("Min" => array_shift($stats['numRounds']), "Max" => array_pop($stats['numRounds'])),
					1 => Array("Min" => 0, "Max" => array_pop($wlr)+0.01),
					2 => Array("Min" => 0, "Max" => 100)
				)
			);
		}
		
		if ($mode == "skill") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['skill'], "elo");
			$myData->setSerieDescription("elo", $tpl->phrase("skill"));
			$myData->setSerieOnAxis("elo", 0);
			
			$myData->addPoints($stats['spm'], "spm");
			$myData->setSerieDescription("spm", $tpl->phrase("spm"));
			$myData->setSerieOnAxis("spm", 1);
			
			$myData->addPoints($stats['kpm'], "kpm");
			$myData->setSerieDescription("kpm", $tpl->phrase("kills_per_minute"));
			$myData->setSerieOnAxis("kpm", 2);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisName(0, $tpl->phrase("skill"));
			$myData->setAxisUnit(0, "");
			
			$myData->setAxisPosition(1, AXIS_POSITION_RIGHT);
			$myData->setAxisName(1, $tpl->phrase("spm"));
			$myData->setAxisUnit(1, "");
			
			$myData->setAxisPosition(2, AXIS_POSITION_RIGHT);
			$myData->setAxisDisplay(2, AXIS_FORMAT_CUSTOM, "YAxisFormat");
			$myData->setAxisName(2, $tpl->phrase("kills_per_minute"));
			$myData->setAxisUnit(2, "");
			
			function YAxisFormat($val) { return(round($val, 2)); } 
			
			/* Skalierung */
			$spm = $stats['spm']; sort($spm);
			$kpm = $stats['kpm']; sort($kpm);
			
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0,
				"ScaleSpacing" => 10,
				"Mode" => SCALE_MODE_MANUAL,
				"ManualScale" => Array(
					0 => Array("Min" => 0, "Max" => 1000),
					1 => Array("Min" => array_shift($spm), "Max" => array_pop($spm)),
					2 => Array("Min" => array_shift($kpm), "Max" => array_pop($kpm))
				)
			);
		}
		
		if ($mode == "kits") {
			/* Y-Achse Werte */
			$myData->addPoints($stats['assault'], "assault");
			$myData->setSerieDescription("assault", "Assault");
			$myData->setSerieOnAxis("assault", 0);
			
			$myData->addPoints($stats['engineer'], "engineer");
			$myData->setSerieDescription("engineer", "Engineer");
			$myData->setSerieOnAxis("assault", 0);
			
			$myData->addPoints($stats['support'], "support");
			$myData->setSerieDescription("support", "Support");
			$myData->setSerieOnAxis("assault", 0);
			
			$myData->addPoints($stats['recon'], "recon");
			$myData->setSerieDescription("recon", "Recon");
			$myData->setSerieOnAxis("assault", 0);
			
			$myData->addPoints($stats['commander'], "commander");
			$myData->setSerieDescription("commander", "Commander");
			$myData->setSerieOnAxis("assault", 0);
			
			/* Y-Achse Skala */
			$myData->setAxisPosition(0, AXIS_POSITION_LEFT);
			$myData->setAxisDisplay(0, AXIS_FORMAT_METRIC);
			$myData->setAxisName(0, $tpl->phrase("score"));
			$myData->setAxisUnit(0, "");
			
			/* Skalierung */
			$ScaleSettings = Array(
				"XMargin"=>0, "YMargin"=>0
			);
		}
	}
	
	
	/* Background */
	$myPicture = new pImage(950, 480, $myData, TRUE);
	$Settings = array("StartR"=>255, "StartG"=>255, "StartB"=>255, "EndR"=>255, "EndG"=>255, "EndB"=>255, "Alpha"=>60);
	$myPicture->drawGradientArea(0,0,950,480,DIRECTION_VERTICAL,$Settings);
	
	
	/* Chart-Title 
	$myPicture->setFontProperties(array("FontName" => "styles/fonts/play-regular-webfont.ttf", "FontSize" => 14));
	$TextSettings = array("Align"=>TEXT_ALIGN_TOPLEFT, "R"=>9, "G"=>96, "B"=>150);
	$myPicture->drawText(40, 40, "PLAYERNAME: ".$tpl->phrase($mode), $TextSettings);*/
	
	
	/* Chart-Area */
	$myPicture->setShadow(FALSE);
	$myPicture->setGraphArea(50,20,860,440);
	$myPicture->setFontProperties(array("R"=>0,"G"=>0,"B"=>0,"FontName"=>"styles/fonts/pchart_arma_five.ttf","FontSize"=>6));
	
	
	/* Skala */
	$myPicture->drawScale($ScaleSettings);
	
	
	/* Lines */
	$Config = "";
	$myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>50,"G"=>50,"B"=>50,"Alpha"=>10));
	$myPicture->drawSplineChart($Config);
	
	
	/* Legend */
	$Config = array("FontR"=>0, "FontG"=>0, "FontB"=>0, "FontName"=>"styles/fonts/pchart_arma_five.ttf", "FontSize"=>6, "Margin"=>6, "Alpha"=>30, "BoxSize"=>5, "Style"=>LEGEND_NOBORDER, "Mode"=>LEGEND_HORIZONTAL);
	$myPicture->drawLegend(40,460,$Config);
	
	
	/* Render image */
	$myPicture->render('tmp/history'.$playerid.'.png');
?>