<?php
	### FORWARDING TO INSTALLER ###
	if (!defined('PLUGIN') AND !file_exists('tmp/sql.php')) {
		header("Status: 301 Moved Permanently");
		header("Location:install/");
		exit; 
	}
	
	
	### LOAD CLASSES ###
	if (true) {
		require 'tmp/sql.php';
		require 'classes/mysql.php';
		
		$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
		
		require 'scripts/vendor/pqlite.php';
		require 'classes/settings.php';
		require 'classes/security.php';
		require 'classes/functions.php';
		require 'classes/template.php';
		require 'classes/player.php';
		require 'classes/stats.php';
		
		
		$func = new Functions();
		$secure = new Security();
		$settings = new Settings();
		$tpl = new Templates();
		$tpl->load_phrases("detail", true);
		$tpl->load_phrases("overview", true);
		$tpl->load_phrases("compare", true);
		$tpl->load_phrases("_bf4_overview", true);
		$tpl->load_phrases("_bf4_compare", true);
	}
	
	
	### SET COMMOM VARIABLES ###
	if (true) {
		$func->counter();                                                       // Start counter function
		$preset = $func->load_settings("settings");                             // Load settings
		$bg_img = $func->load_settings("style"); $bg_img = $bg_img['body_bg_image'];   // Filename of Wallpaper image
		$ov = $func->load_settings("overview");                                 // Load leaderboard columns
		date_default_timezone_set($preset["settings_timezone"]);                // Set timezone
		$lastupdate = date("d.m.Y - H:i", $preset["update_date_last_refresh"]); // Last update of all players
		$data = Array( "player"  => Array(), "summary" => Array() );            // Array with the leaderboard values
		
	}
	
	
	### LOAD COLUMNS / CREATE TABLE HEADER ###
	if (true) {
		// Load admin phrases in separate class, for extended Table Head descriptions
		$tp2 = new Templates();
		$tp2->load_phrases("admin", true);
		$tp2->load_phrases("_bf4_admin", true);
		
		$i = 0;
		$thead = "<tr>";
		$sortList = "[[0,1]]";
		
		foreach ($ov as $name => $active) {
			if ($active) {
				// Create all table headers, which are activated in Adminpanel->Customize
				// Append tooltip if there is a extended Table Head description
				$a = $tpl->phrase($name);
				$b = $tp2->phrase($name);
				if ($a == $b)	$thead .= '<th><span>'.$a.'</span></th>';
				else			$thead .= '<th><span title="'.$b.'">'.$a.'</span></th>';
				
				// Save this column to data array
				$data['summary'][$name] = Array();
				
				// Reverse sortation, if "Position" is the first column
				if ($i == 0 AND $name == 'position') $sortList = "[[0,0]]";
				
				$i++;
			}
		}
		
		$thead .= "</tr>";
	}
	
	
	### LOAD DATA ###
	if (true) {
		$i = 0;
		$path   = (defined('PLUGIN')) ? $settings->get("properties_path") : "";
		$plugin = (defined('PLUGIN')) ? "1" : "0";
		
		// Function for creating cell- and tooltipp-HTML
		function html($result, $class="", $tooltip=false) {
			$class = ($class != "") ? ' class="'.$class.'"' : "";
			
			if (!$tooltip) {
				return '<td'.$class.' sort="'.$result['sort'].'"><div title="'.strip_tags($result['tip']).'">'.$result['format'].'</div></td>';
			}
			
			else {
				$style       = ($tooltip['style'] != "")       ? ' style="'.$tooltip['style'].'"'             : "";
				$trigger     = ($tooltip['trigger'] != "")     ? ' trigger-style="'.$tooltip['trigger'].'"'   : "";
				$orientation = ($tooltip['orientation'] != "") ? ' orientation="'.$tooltip['orientation'].'"' : "";
				
				return '<td'.$class.' sort="'.$result['sort'].'"><div>'.$result['format'].'</div><x-tooltip '.$orientation.' '.$trigger.' '.$style.'>'.$result['tip'].'</x-tooltip></td>';
			}
		}
		
		
		// Load IDs of player with playtime greater than 0 ordered by score
		if (true) {
			$sql->query('
				SELECT id
				FROM '.$sql->prefix.'stats__basic
				WHERE timePlayed != 0
				ORDER BY score DESC
			');
		}
		
		
		// Iterate through players
		while ($row = $sql->fetchAssoc()) {
			$i++;
			$stats = new Stats($row['id']);
			$data['player'][$i] = Array();
			
			
			if ($ov['position']) {
				$column = 'position';
				$result = $stats->form($i, Array('number', 0, '', 'position'), false);
				
				$data['player'][$i][$column]  = html($result);
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td> </td>',
						'med' => '<td> </td>',
						'sum' => '<td> </td>'
					);
				}
			}
			
			
			if ($ov['rank']) {
				$column = 'rank';
				
				$rank = $stats->get('basic', 'rank');
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $func->rank_image($rank->nr, $path),
					'tip' =>    $rank->name,
					'sort' =>   $rank->nr
				), "tcenter");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['platform']) {
				$column = 'platform';
				
				$opt  = $preset['features_rankicon'];
				$img  = $path.'styles/icons/platform/'.$opt.'.png';
				
				$size = Array(
					'tiny' => 32,
					'small' => 48,
					'medium' => 64,
					'large' => 128
				);
				
				$offset = Array(
					"pc" => 0,
					"xbox" => 1 * $size[$opt],
					"xone" => 2 * $size[$opt],
					"ps3" => 3 * $size[$opt],
					"ps4" => 4 * $size[$opt]
				);
				
				$y = $offset[$stats->get('basic', 'plat')];
				
				$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
				$tip = $tp2->phrase($column).': '.strtoupper($stats->get('basic', 'plat'));
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $div,
					'tip' =>    $tip,
					'sort' =>   $stats->get('basic', 'plat')
				), "tcenter");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['kits']) {
				$column = 'kits';
				$kits   = $stats->get('stats', 'kits');
				$opt    = $preset['features_rankicon'];
				$img    = $path.'styles/icons/kits/'.$opt.'.png';
				$array  = Array();
				
				foreach ($kits as $name => $obj) {
					$array[$obj->time] = $name;
				}
				ksort($array);
				$result = array_pop($array);
				
				
				$size = Array(
					'tiny' => 32,
					'small' => 48,
					'medium' => 64,
					'large' => 128
				);
				
				$offset = Array(
					"assault" => 0,
					"engineer" => 1 * $size[$opt],
					"support" => 2 * $size[$opt],
					"recon" => 3 * $size[$opt],
					"commander" => 4 * $size[$opt]
				);
				
				$y = $offset[$result];
				
				$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $div,
					'tip' =>    $kits->$result->name,
					'sort' =>   $result
				), "tcenter");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['vehcats']) {
				$column = 'vehcats';
				$vehcats   = $stats->get('vehicleCategory');
				$opt    = $preset['features_rankicon'];
				$img    = $path.'styles/icons/vehcats/'.$opt.'.png';
				$array  = Array();
				$vehcats_offset = array_flip(Array('Infantry Fighting Vehicle', 'Anti Air', 'Air Jet Stealth', 'Air Jet Attack', 'Weapon Stationary', 'Main Battle Tanks', 'Transport', 'Air Helicopter Attack', 'Air Helicopter Scout', 'Fast Attack Craft', 'Soldier Equiment', 'Boat', 'Mobile Artillery', 'Air', 'Weapon Stationary AA'));
				
				foreach ($vehcats as $obj) {
					$array[$obj->stat->time] = $obj->name;
				}
				ksort($array);
				$result = array_pop($array);
				
				$size = Array(
					'tiny' => 32,
					'small' => 48,
					'medium' => 64,
					'large' => 128
				);
				
				$y = $vehcats_offset[trim($result)] * $size[$opt];
				
				$div = '<div style="width: '.$size[$opt].'px; height: '.$size[$opt].'px; background-image: url('.$img.'); background-position: 0 -'.$y.'px"></div>';
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $div,
					'tip' =>    $result,
					'sort' =>   $result
				), "tcenter");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['country']) {
				$column = 'country';
				
				if ($stats->get('basic', 'country') != "") {
					$data['player'][$i][$column]  = html(Array(
						'format' => '<img src="'.$path.'styles/icons/flags/'.strtolower($stats->get('basic', 'country')).'.png" />',
						'tip' =>    $stats->get('basic', 'countryName'),
						'sort' =>   $stats->get('basic', 'countryName')
					), "tcenter");
				} else {
					$data['player'][$i][$column]  = html(Array(
						'format' => '<img src="'.$path.'styles/icons/flags/none.png" />',
						'tip' =>    "",
						'sort' =>   ""
					), "tcenter");
				}
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['name']) {
				$column = 'name';
				
				$nickname = $stats->get('player', 'nickname');
				$name     = $stats->get('basic', 'name');
				$nname    = ($nickname != "") ? $nickname : $name;
				$tag      = $stats->get('basic', 'tag') ? '['.$stats->get('basic', 'tag').']' : "";
				$clantag  = $settings->get('settings_clantag') ? $settings->get('settings_clantag') : $tag;
				$tip      = $tpl->phrase("open_detail_view"); eval ( "\$tip = \"$tip\";" );
				
				$data['player'][$i][$column]  = html(Array(
					'sort' =>   $nname,
					'format' => '<a class="ezPopup" href="'.$path.'detail.php?pid='.$row['id'].'&plugin='.$plugin.'">'.$clantag.$nname.'</a>',
					'tip' =>    $tpl->phrase("click_to_get_detailed_view"),
				), "tleft");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td>'.$tpl->phrase("ov_averages").': </td>',
						'med' => '<td>'.$tpl->phrase("ov_median").': </td>',
						'sum' => '<td>'.$tpl->phrase("ov_summary").': </td>'
					);
				}
			}
			
			
			if ($ov['custom1']) {
				$column = 'custom1';
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $stats->get('player', 'custom'),
					'tip' =>    '',
					'sort' =>   $stats->get('player', 'custom')
				), "tleft");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['score']) {
				$column = 'score';
				$result = $stats->get('basic', 'score', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('number', 0, "k"), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['skill']) {
				$column = 'skill';
				$result = $stats->get('stats', 'skill', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$data['summary'][$column]['sum'] = '<td></td>';
					}
				}
			}
			
			
			if ($ov['time']) {
				$column = 'time';
				$result = $stats->get('stats', 'timePlayed', Array('time', 0, 'h'), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('time', 0, 'h'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('time', 0, 'h'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('time', 0, 'h'), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['spm']) {
				$column = 'spm';
				$time =   $stats->get('stats', 'timePlayed') / 60;
				$result = $stats->get('basic', 'score', Array('ratio', $time, 0, '', $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$data['summary'][$column]['sum'] = '<td></td>';
					}
				}
			}
			
			
			if ($ov['kills']) {
				$column = 'kills';
				$result = $stats->get('stats', 'kills', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('number', 0, "k"), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['deaths']) {
				$column = 'deaths';
				$result = $stats->get('stats', 'deaths', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('number', 0, "k"), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['kdr']) {
				$column = 'kdr';
				$deaths = $stats->get('stats', 'deaths');
				$result = $stats->get('stats', 'kills', Array('ratio', $deaths, 2, '', $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number', 2), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number', 2), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$data['summary'][$column]['sum'] = '<td></td>';
					}
				}
			}
			
			
			if ($ov['acc']) {
				$column = 'acc';
				$shots =  $stats->get('stats', 'shotsFired');
				$result = $stats->get('stats', 'shotsHit', Array('ratio', $shots, 0, '%', $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number', 0, '%'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number', 0, '%'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$data['summary'][$column]['sum'] = '<td></td>';
					}
				}
			}
			
			
			if ($ov['wins']) {
				$column = 'wins';
				$result = $stats->get('stats', 'numWins', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('number', 0, "k"), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['loss']) {
				$column = 'loss';
				$result = $stats->get('stats', 'numLosses', Array('number', 0, "", $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number'), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$result = array_sum($array);
						$result = $stats->form($result, Array('number', 0, "k"), false);
						$data['summary'][$column]['sum'] = html($result);
					}
				}
			}
			
			
			if ($ov['wlr']) {
				$column = 'wlr';
				$loss =   $stats->get('stats', 'numLosses');
				$result = $stats->get('stats', 'numWins', Array('ratio', $loss, 2, '', $column), false);
				
				$data['player'][$i][$column]  = html($result);
				$data['summary'][$column][$i] = $result['raw'];
				
				// Summary
				if ($i == $sql->count()) {
					$array = $data['summary'][$column];
					$data['summary'][$column] = Array();
					
					if ($preset['features_averages']) {
						$result = $func->calculate_average($array);
						$result = $stats->form($result, Array('number', 2), false);
						$data['summary'][$column]['avg'] = html($result);
					}
					
					if ($preset['features_median']) {
						$result = $func->calculate_median($array);
						$result = $stats->form($result, Array('number', 2), false);
						$data['summary'][$column]['med'] = html($result);
					}
					
					if ($preset['features_summary']) {
						$data['summary'][$column]['sum'] = '<td></td>';
					}
				}
			}
			
			
			if ($ov['weapons']) {
				$column = 'weapons';
				$weapons = $stats->get('weapons');
				$array  = Array();
				
				foreach ($weapons as $key => $obj) {
					$array[$obj->stat->kills] = $key;
				}
				ksort($array);
				$result = array_pop($array);
				
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $weapons[$result]->name,
					'tip' =>    $weapons[$result]->detail->type,
					'sort' =>   $result
				), "tleft");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
			
			if ($ov['vehicles']) {
				$column = 'vehicles';
				$vehicles = $stats->get('vehicles');
				$array  = Array();
				
				foreach ($vehicles as $key => $obj) {
					$array[$obj->stat->kills] = $key;
				}
				ksort($array);
				$result = array_pop($array);
				
				
				$data['player'][$i][$column]  = html(Array(
					'format' => $vehicles[$result]->name,
					'tip' =>    $vehicles[$result]->detail->category,
					'sort' =>   $result
				), "tleft");
				
				// Summary
				if ($i == $sql->count()) {
					$data['summary'][$column] = Array(
						'avg' => '<td></td>',
						'med' => '<td></td>',
						'sum' => '<td></td>'
					);
				}
			}
			
		}
	}
	
	
	### CREATE TABLE BODY AND FOOT ###
	if (true) {
		$tbody = Array();
		foreach ($data['player'] as $p) {
			$html = "";
			
			foreach ($ov as $name => $active) {
				if ($active) {
					$html .= $p[$name];
				}
			}
			$tbody[] = $html;
		}
		$tbody = "<tr>". implode("</tr><tr>", $tbody) ."</tr>";
		
		
		$tfoot = Array('avg'=>'', 'med'=>'', 'sum'=>'');
		foreach ($ov as $name => $active) {
			$html = "";
			
			if ($active) {
				if ($preset['features_averages']) $tfoot['avg'][] = $data['summary'][$name]['avg'];
				if ($preset['features_median'])   $tfoot['med'][] = $data['summary'][$name]['med'];
				if ($preset['features_summary'])  $tfoot['sum'][] = $data['summary'][$name]['sum'];
			}
		}
		
		if ($preset['features_averages']) $tfoot['avg'] = "<tr>". implode($tfoot['avg'])."</tr>";
		if ($preset['features_median'])   $tfoot['med'] = "<tr>". implode($tfoot['med'])."</tr>";
		if ($preset['features_summary'])  $tfoot['sum'] = "<tr>". implode($tfoot['sum'])."</tr>";
		
		$tfoot = implode($tfoot);
	}
	
	
	### PAGE OUTPUT ###
	if (true) {
		if (defined('PLUGIN')) {
			$selfadd = $preset['features_selfadd'] == "1" ? '<td id="ezSelfadd"><a href="'.$preset['properties_path'].'admin/index.php?selfadd" target="_blank">'.$tpl->phrase("selfadd").'</a></td>' : "";
			
			eval ("\$html = \"".$tpl->template("plugin")."\";");
			$html = str_replace('#PATH#', $preset['properties_path'], $html);
			$html = new PQLite($html);
			
			if ($preset['features_compare']) {
				eval ("\$compare = \"".$tpl->template("compare")."\";");
				$compare = str_replace('compare.php?', $preset['properties_path'].'compare.php?plugin=1&amp;', $compare);
				
				$html->find('#ezCompare')->appendHTML($compare);
			}
		} else {
			$selfadd = $preset['features_selfadd'] == "1" ? '<a href="admin/index.php?selfadd" id="ezSelfadd" target="_blank">'.$tpl->phrase("selfadd").'</a>' : "";
			
			eval ("\$html = \"".$tpl->template("standalone")."\";");
			$html = new PQLite($html);
			
			if ($preset['features_compare']) {
				eval ("\$compare = \"".$tpl->template("compare")."\";");
				$compare = str_replace('compare.php?', 'compare.php?plugin=0&amp;', $compare);
				
				$html->find('#ezCompare')->appendHTML($compare);
			}
		}
	}
	
	
	$html->find('#ezOverview')->appendHTML("<thead>".$thead."</thead>");
	$html->find('#ezOverview')->appendHTML("<tfoot>".$tfoot."</tfoot>");
	$html->find('#ezOverview')->appendHTML("<tbody>".$tbody."</tbody>");
	
	if (!$preset['features_infobox']) $html->find('#ezAside')->remSelf();
	if (!$preset['features_brand'])   $html->find('#ezBrand')->remSelf();
	if (!$preset['features_compare']) $html->find('#ezCompare')->remSelf();
	
	echo $html->getHTML();
?>